<?php
/* Project Custom Post Type */
if( !function_exists( 'create_Project_post_type' ) ){
    function create_Project_post_type(){

      $labels = array(
            'name' => esc_html__( 'Projects','casaroyal'),
            'singular_name' => esc_html__( 'Project','casaroyal' ),
            'add_new' => esc_html__('Add New','casaroyal'),
            'add_new_item' => esc_html__('Add New Project','casaroyal'),
            'edit_item' => esc_html__('Edit Project','casaroyal'),
            'new_item' => esc_html__('New Project','casaroyal'),
            'view_item' => esc_html__('View Project','casaroyal'),
            'search_items' => esc_html__('Search Project','casaroyal'),
            'not_found' =>  esc_html__('No Project found','casaroyal'),
            'not_found_in_trash' => esc_html__('No Project found in Trash','casaroyal'),
            'parent_item_colon' => ''
          );

      $args = array(
            'labels' => $labels,
            'public' => true,
            'publicly_queryable' => true,
            'show_ui' => true,
            'query_var' => true,
            'has_archive' => true,
            'capability_type' => 'post',
            'hierarchical' => true,
            'menu_icon' => 'dashicons-admin-page',
            'menu_position' => 5,
            'supports' => array('title','editor','author','thumbnail'),
            'rewrite' => array( 'slug' => esc_html__('project', 'casaroyal') )
      );

      register_post_type('project',$args);

    }
}
add_action('init', 'create_Project_post_type');


/* Create Project Taxonomies */
if( !function_exists( 'build_taxonomies_Project' ) ){
    function build_taxonomies_Project(){
        $labels = array(
            'name' => esc_html__( 'Categories', 'casaroyal' ),
            'singular_name' => esc_html__( 'Categories', 'casaroyal' ),
            'search_items' =>  esc_html__( 'Search Categories', 'casaroyal' ),
            'popular_items' => esc_html__( 'Popular Categories', 'casaroyal' ),
            'all_items' => esc_html__( 'All Categories', 'casaroyal' ),
            'parent_item' => esc_html__( 'Parent Category', 'casaroyal' ),
            'parent_item_colon' => esc_html__( 'Parent Category:', 'casaroyal' ),
            'edit_item' => esc_html__( 'Edit Category', 'casaroyal' ),
            'update_item' => esc_html__( 'Update Category', 'casaroyal' ),
            'add_new_item' => esc_html__( 'Add New Category', 'casaroyal' ),
            'new_item_name' => esc_html__( 'New Category Name', 'casaroyal' ),
            'separate_items_with_commas' => esc_html__( 'Separate Categories with commas', 'casaroyal' ),
            'add_or_remove_items' => esc_html__( 'Add or remove Categories', 'casaroyal' ),
            'choose_from_most_used' => esc_html__( 'Choose from the most used Categories', 'casaroyal' ),
            'menu_name' => esc_html__( 'Categories', 'casaroyal' )
        );

        register_taxonomy(
            'project-category',
            array('project'),
            array(
                'hierarchical' => true,
                'labels' => $labels,
                'show_ui' => true,
                'query_var' => true,
                'rewrite' => array('slug' => esc_html__('project-category', 'casaroyal'))
            )
        );
    }
}
add_action( 'init', 'build_taxonomies_Project', 0 );

?>