<?php
/* Testimonial Custom Post Type */
if( !function_exists( 'create_Testimonial_post_type' ) ){
    function create_Testimonial_post_type(){

      $labels = array(
            'name' => esc_html__( 'Testimonials','casaroyal'),
            'singular_name' => esc_html__( 'Testimonial','casaroyal' ),
            'add_new' => esc_html__('Add New','casaroyal'),
            'add_new_item' => esc_html__('Add New Testimonial','casaroyal'),
            'edit_item' => esc_html__('Edit Testimonial','casaroyal'),
            'new_item' => esc_html__('New Testimonial','casaroyal'),
            'view_item' => esc_html__('View Testimonial','casaroyal'),
            'search_items' => esc_html__('Search Testimonial','casaroyal'),
            'not_found' =>  esc_html__('No Testimonial found','casaroyal'),
            'not_found_in_trash' => esc_html__('No Testimonial found in Trash','casaroyal'),
            'parent_item_colon' => ''
          );

      $args = array(
            'labels' => $labels,
            'public' => true,
            'publicly_queryable' => true,
            'show_ui' => true,
            'query_var' => true,
            'has_archive' => true,
            'capability_type' => 'post',
            'hierarchical' => true,
            'menu_icon' => 'dashicons-format-quote',
            'menu_position' => 5,
            'supports' => array('title','editor','revisions','author','thumbnail'),
            'rewrite' => array( 'slug' => esc_html__('Testimonial', 'casaroyal') )
      );

      register_post_type('testimonial',$args);

    }
}
add_action('init', 'create_Testimonial_post_type');

/* Add Custom Columns */
if( !function_exists( 'testimonial_edit_columns' ) ){
    function testimonial_edit_columns($columns)
    {

        $columns = array(
            "cb" => "<input type=\"checkbox\" />",
            "title" => esc_html__( 'Title','casaroyal' ),
            "position" => esc_html__('Position','casaroyal'),
            "date" => esc_html__( 'Publish Time','casaroyal' )
        );

        //WPML support
        if ( defined( 'ICL_LANGUAGE_CODE' ) ) {
            global $sitepress;
            $columns = $sitepress->add_posts_management_column( $columns );
        }

        return $columns;
    }
}
add_filter("manage_edit-testimonial_columns", "testimonial_edit_columns");

if( !function_exists( 'testimonial_custom_columns' ) ){
    function testimonial_custom_columns($column){
        global $post;
        switch ($column)
        {
            case 'position':
                $bath = get_post_meta($post->ID,'ft_testimonial_position',true);
                if(!empty($bath)){
                    echo $bath;
                }
                else{
                    esc_html_e('N/A','casaroyal');
                }
                break;
            
      }
    }
}
add_action("manage_pages_custom_column", "testimonial_custom_columns");

?>