<?php
/* Create Custom Post Type : Agent */
if( !function_exists( 'create_agent_post_type' ) ){
    function create_agent_post_type(){
        $labels = array(
            'name' => esc_html__( 'Agents','casaroyal'),
            'singular_name' => esc_html__( 'Agent','casaroyal' ),
            'add_new' => esc_html__('Add New','casaroyal'),
            'add_new_item' => esc_html__('Add New Agent','casaroyal'),
            'edit_item' => esc_html__('Edit Agent','casaroyal'),
            'new_item' => esc_html__('New Agent','casaroyal'),
            'view_item' => esc_html__('View Agent','casaroyal'),
            'search_items' => esc_html__('Search Agent','casaroyal'),
            'not_found' =>  esc_html__('No Agent found','casaroyal'),
            'not_found_in_trash' => esc_html__('No Agent found in Trash','casaroyal'),
            'parent_item_colon' => ''
        );

        $args = array(
            'labels' => $labels,
            'public' => true,
            'exclude_from_search' => true,
            'publicly_queryable' => true,
            'show_ui' => true,
            'query_var' => true,
            'capability_type' => 'post',
            'hierarchical' => false,
            'menu_icon' => 'dashicons-businessman',
            'menu_position' => 5,
            'supports' => array('title','editor','thumbnail','revisions'),
            'rewrite' => array( 'slug' => esc_html__('agent', 'casaroyal') )
        );

        register_post_type('agent',$args);
    }
}
add_action( 'init', 'create_agent_post_type' );

?>