<?php
/* Property Custom Post Type */
if( !function_exists( 'create_property_post_type' ) ){
    function create_property_post_type(){

      $labels = array(
            'name' => esc_html__( 'Properties','casaroyal'),
            'singular_name' => esc_html__( 'Property','casaroyal' ),
            'add_new' => esc_html__('Add New','casaroyal'),
            'add_new_item' => esc_html__('Add New Property','casaroyal'),
            'edit_item' => esc_html__('Edit Property','casaroyal'),
            'new_item' => esc_html__('New Property','casaroyal'),
            'view_item' => esc_html__('View Property','casaroyal'),
            'search_items' => esc_html__('Search Property','casaroyal'),
            'not_found' =>  esc_html__('No Property found','casaroyal'),
            'not_found_in_trash' => esc_html__('No Property found in Trash','casaroyal'),
            'parent_item_colon' => ''
          );

      $args = array(
            'labels' => $labels,
            'public' => true,
            'publicly_queryable' => true,
            'show_ui' => true,
            'query_var' => true,
            'has_archive' => true,
            'capability_type' => 'post',
            'hierarchical' => true,
            'menu_icon' => 'dashicons-building',
            'menu_position' => 5,
            'supports' => array('title','editor','thumbnail','revisions','author','page-attributes','excerpt'),
            'rewrite' => array( 'slug' =>  'property' )
      );

      register_post_type('property',$args);

    }
}
add_action('init', 'create_property_post_type');


/* Create Property Taxonomies */
if( !function_exists( 'build_taxonomies' ) ){
    function build_taxonomies(){
        $labels = array(
            'name' => esc_html__( 'Property Features', 'casaroyal' ),
            'singular_name' => esc_html__( 'Property Features', 'casaroyal' ),
            'search_items' =>  esc_html__( 'Search Property Features', 'casaroyal' ),
            'popular_items' => esc_html__( 'Popular Property Features', 'casaroyal' ),
            'all_items' => esc_html__( 'All Property Features', 'casaroyal' ),
            'parent_item' => esc_html__( 'Parent Property Feature', 'casaroyal' ),
            'parent_item_colon' => esc_html__( 'Parent Property Feature:', 'casaroyal' ),
            'edit_item' => esc_html__( 'Edit Property Feature', 'casaroyal' ),
            'update_item' => esc_html__( 'Update Property Feature', 'casaroyal' ),
            'add_new_item' => esc_html__( 'Add New Property Feature', 'casaroyal' ),
            'new_item_name' => esc_html__( 'New Property Feature Name', 'casaroyal' ),
            'separate_items_with_commas' => esc_html__( 'Separate Property Features with commas', 'casaroyal' ),
            'add_or_remove_items' => esc_html__( 'Add or remove Property Features', 'casaroyal' ),
            'choose_from_most_used' => esc_html__( 'Choose from the most used Property Features', 'casaroyal' ),
            'menu_name' => esc_html__( 'Property Features', 'casaroyal' )
        );

        register_taxonomy(
            'property-feature',
            'property',
            array(
                'hierarchical' => true,
                'labels' => $labels,
                'show_ui' => true,
                'query_var' => true,
                'publicly_queryable' => true,
                'rewrite' => array( 'slug' => 'property-feature' )
            )
        );


        $type_labels = array(
            'name' => esc_html__( 'Property Type', 'casaroyal' ),
            'singular_name' => esc_html__( 'Property Type', 'casaroyal' ),
            'search_items' =>  esc_html__( 'Search Property Types', 'casaroyal' ),
            'popular_items' => esc_html__( 'Popular Property Types', 'casaroyal' ),
            'all_items' => esc_html__( 'All Property Types', 'casaroyal' ),
            'parent_item' => esc_html__( 'Parent Property Type', 'casaroyal' ),
            'parent_item_colon' => esc_html__( 'Parent Property Type:', 'casaroyal' ),
            'edit_item' => esc_html__( 'Edit Property Type', 'casaroyal' ),
            'update_item' => esc_html__( 'Update Property Type', 'casaroyal' ),
            'add_new_item' => esc_html__( 'Add New Property Type', 'casaroyal' ),
            'new_item_name' => esc_html__( 'New Property Type Name', 'casaroyal' ),
            'separate_items_with_commas' => esc_html__( 'Separate Property Types with commas', 'casaroyal' ),
            'add_or_remove_items' => esc_html__( 'Add or remove Property Types', 'casaroyal' ),
            'choose_from_most_used' => esc_html__( 'Choose from the most used Property Types', 'casaroyal' ),
            'menu_name' => esc_html__( 'Property Types', 'casaroyal' )
        );

        register_taxonomy(
            'property-type',
            'property',
            array(
                'hierarchical' => true,
                'labels' => $type_labels,
                'show_ui' => true,
                'query_var' => true,
                'publicly_queryable' => true,
                'rewrite' => array(
                    'slug' => 'property-type',
                    'with_front' => false,
                ),
            )
        );

        //
        $city_labels = array(
            'name' => esc_html__( 'Property City', 'casaroyal' ),
            'singular_name' => esc_html__( 'Property City', 'casaroyal' ),
            'search_items' =>  esc_html__( 'Search Property Cities', 'casaroyal' ),
            'popular_items' => esc_html__( 'Popular Property Cities', 'casaroyal' ),
            'all_items' => esc_html__( 'All Property Cities', 'casaroyal' ),
            'parent_item' => esc_html__( 'Parent Property City', 'casaroyal' ),
            'parent_item_colon' => esc_html__( 'Parent Property City:', 'casaroyal' ),
            'edit_item' => esc_html__( 'Edit Property City', 'casaroyal' ),
            'update_item' => esc_html__( 'Update Property City', 'casaroyal' ),
            'add_new_item' => esc_html__( 'Add New Property City', 'casaroyal' ),
            'new_item_name' => esc_html__( 'New Property City Name', 'casaroyal' ),
            'separate_items_with_commas' => esc_html__( 'Separate Property Cities with commas', 'casaroyal' ),
            'add_or_remove_items' => esc_html__( 'Add or remove Property Cities', 'casaroyal' ),
            'choose_from_most_used' => esc_html__( 'Choose from the most used Property Cities', 'casaroyal' ),
            'menu_name' => esc_html__( 'Property Cities', 'casaroyal' )
        );

        $city_args = array(
            'hierarchical'      => true,
            'labels'            => $city_labels,
            'show_ui'           => true,
            'show_admin_column' => true,
            'query_var'         => true,
            'publicly_queryable' => true,
            'rewrite' => array(
                'slug' => 'property-city',
                'with_front' => false,
            ),
        );

        register_taxonomy( 'property-city', array( 'property' ), $city_args );

        //
        $status_labels = array(
            'name' => esc_html__( 'Property Status', 'casaroyal' ),
            'singular_name' => esc_html__( 'Property Status', 'casaroyal' ),
            'search_items' =>  esc_html__( 'Search Property Status', 'casaroyal' ),
            'popular_items' => esc_html__( 'Popular Property Status', 'casaroyal' ),
            'all_items' => esc_html__( 'All Property Status', 'casaroyal' ),
            'parent_item' => esc_html__( 'Parent Property Status', 'casaroyal' ),
            'parent_item_colon' => esc_html__( 'Parent Property Status:', 'casaroyal' ),
            'edit_item' => esc_html__( 'Edit Property Status', 'casaroyal' ),
            'update_item' => esc_html__( 'Update Property Status', 'casaroyal' ),
            'add_new_item' => esc_html__( 'Add New Property Status', 'casaroyal' ),
            'new_item_name' => esc_html__( 'New Property Status Name', 'casaroyal' ),
            'separate_items_with_commas' => esc_html__( 'Separate Property Status with commas', 'casaroyal' ),
            'add_or_remove_items' => esc_html__( 'Add or remove Property Status', 'casaroyal' ),
            'choose_from_most_used' => esc_html__( 'Choose from the most used Property Status', 'casaroyal' ),
            'menu_name' => esc_html__( 'Property Status', 'casaroyal' )
        );

        register_taxonomy(
            'property-status',
            'property',
            array(
                'hierarchical' => true,
                'labels' => $status_labels,
                'show_ui' => true,
                'query_var' => true,
                'publicly_queryable' => true,
                'rewrite' => array( 'slug' => 'property-status' )
            )
        );

        $taxonomies = array(
            'property-feature' => array(
                '2 Stories',
                '26′ Ceilings',
                'Central Heating',
                'Dual Sinks',
                'Electric Range',
                'Emergency Exit',
                'Fire Alarm',
                'Fire Place',
                'Home Theater',
                'Hurricane Shutters',
                'Laundry Room',
                'Lawn',
                'Marble Floors',
                'NEXT to busway',
                'Swimming Pool',
                'Wifi'
            ),
            'property-type' => array(
                'Commercial' => array(
                    'Commercial',
                    'Office',
                    'Shop'
                ),
                'Condo',
                'Residential' => array(
                    'Residential',
                    'Apartment',
                    'House',
                    'Residential Tower',
                    'Summer House'
                ),
            ),
            'property-city' => array(
                'Beverly Hills',
                'Los Angeles',
                'Mission Viejo',
                'Newport Beach',
                'Pasadena',
                'Santa Monica'
            ),
            'property-status' => array(
                'For Rent',
                'For Sale'
            ),
        );

        $casaroyal_installed_terms = get_option( 'casaroyal_installed_terms' );

        if( !isset($casaroyal_installed_terms) OR empty($casaroyal_installed_terms) ) {

            foreach ( $taxonomies as $taxonomy => $terms ) {

                foreach ( $terms as $term ) {

                    if( is_array( $term ) ) {

                        if ( ! get_term_by( 'slug', sanitize_title( $term[0] ), $taxonomy ) ) {
                            
                            $submit_term = wp_insert_term( $term[0], $taxonomy );

                            if ( is_wp_error( $submit_term ) ) {
                                $error_string = $submit_term->get_error_message();
                                echo '<div id="message" class="error"><p>' . $error_string . ' - ' . $taxonomy . ' - ' . $s . '</p></div>';
                            }

                            if ( ! is_wp_error( $submit_term ) ) {
                                // Get term_id, set default as 0 if not set
                                $term_id = isset( $submit_term['term_id'] ) ? $submit_term['term_id'] : 0;

                                foreach ( $term as $sub_term ) {

                                    if ( ! get_term_by( 'slug', sanitize_title( $sub_term ), $taxonomy ) ) {

                                        if( $term[0] != $sub_term ) {

                                            $submit_term = wp_insert_term( $sub_term, $taxonomy, array( 'parent' => $term_id) );

                                        }

                                    }

                                }
                            }

                        };

                    } else {
                        
                        if ( ! get_term_by( 'slug', sanitize_title( $term ), $taxonomy ) ) {
                            
                            $submit_term = wp_insert_term( $term, $taxonomy );

                            if ( ! is_wp_error( $submit_term ) ) {
                                // Get term_id, set default as 0 if not set
                                $term_id = isset( $submit_term['term_id'] ) ? $submit_term['term_id'] : 0;
                            }

                            if ( is_wp_error( $submit_term ) ) {
                                $error_string = $submit_term->get_error_message();
                                echo '<div id="message" class="error"><p>' . $error_string . ' - ' . $taxonomy . ' - ' . $s . '</p></div>';
                            }

                        }

                    }

                }

            }

            if( isset($submit_term) && !is_wp_error($submit_term) && isset($submit_term['term_id']) ) {
                update_option( 'casaroyal_installed_terms', 1 );
            }

        }
    }
}
add_action( 'init', 'build_taxonomies', 0 );


/* Add Custom Columns */
if( !function_exists( 'property_edit_columns' ) ){
    function property_edit_columns($columns)
    {

        $columns = array(
            "cb" => "<input type=\"checkbox\" />",
            "title" => esc_html__( 'Property Title','casaroyal' ),
            "thumb" => esc_html__( 'Thumbnail','casaroyal' ),
            //"address" => esc_html__('Address','casaroyal'),
            "city" => esc_html__( 'City','casaroyal' ),
            "type" => esc_html__('Type','casaroyal'),
            "status" => esc_html__('Status','casaroyal'),
            "price" => esc_html__('Price','casaroyal'),
            "id" => esc_html__( 'Property ID','casaroyal' ),
            "agent" => esc_html__( 'Property Agent','casaroyal' ),
            /*
            "bed" => esc_html__('Beds','casaroyal'),
            "bath" => esc_html__('Baths','casaroyal'),
            "garage" => esc_html__('Garages','casaroyal'),
            "features" => esc_html__('Features','casaroyal'),
            */
            "date" => esc_html__( 'Publish Time','casaroyal' )
        );

        //WPML support
        if ( defined( 'ICL_LANGUAGE_CODE' ) ) {
            global $sitepress;
            $columns = $sitepress->add_posts_management_column( $columns );
        }

        return $columns;
    }
}
add_filter("manage_edit-property_columns", "property_edit_columns");

if( !function_exists( 'property_custom_columns' ) ){
    function property_custom_columns($column){
        global $post;
        switch ($column)
        {
            case 'thumb':
                if(has_post_thumbnail($post->ID)){
                    ?>
                    <a href="<?php the_permalink(); ?>" target="_blank">
                        <?php the_post_thumbnail( array( 130, 130 ) );?>
                    </a>
                    <?php
                }
                else{
                    esc_html_e('No Thumbnail','casaroyal');
                }
                break;
            case 'id':
                $Prop_id = get_post_meta($post->ID,'ft_property_sku',true);
                if(!empty($Prop_id)){
                    echo $Prop_id;
                }
                else{
                    esc_html_e('N/A','casaroyal');
                }
                break;
            case 'agent':
	            $agents_id = get_post_meta( $post->ID, 'ft_agents' );
	            if ( ! empty( $agents_id ) ) {
		            $agents_title = array();
		            foreach ( $agents_id as $agent_id ) {
			            $agents_title[] = get_the_title( $agent_id );
		            }
		            echo implode( ', ', $agents_title );
	            } else {
		            esc_html_e( 'N/A', 'casaroyal' );
	            }
                break;
            case 'city':
                echo casaroyal_admin_taxonomy_terms ( $post->ID, 'property-city', 'property' );
                break;
            case 'address':
                $address = get_post_meta($post->ID,'ft_property_address',true);
                if(!empty($address)){
                    echo $address;
                }
                else{
                    esc_html_e('No Address Provided!','casaroyal');
                }
                break;
            case 'type':
                echo casaroyal_admin_taxonomy_terms ( $post->ID, 'property-type', 'property' );
                break;
            case 'status':
                echo casaroyal_admin_taxonomy_terms ( $post->ID, 'property-status', 'property' );
                break;
            case 'price':
                property_price();
                break;
            case 'bed':
                $bed = get_post_meta($post->ID,'ft_property_bedrooms',true);
                if(!empty($bed)){
                    echo $bed;
                }
                else{
                    esc_html_e('N/A','casaroyal');
                }
                break;
            case 'bath':
                $bath = get_post_meta($post->ID,'ft_property_bathrooms',true);
                if(!empty($bath)){
                    echo $bath;
                }
                else{
                    esc_html_e('N/A','casaroyal');
                }
                break;
            case 'garage':
                $garage = get_post_meta($post->ID,'ft_property_garage',true);
                if(!empty($garage)){
                    echo $garage;
                }
                else{
                    esc_html_e('N/A','casaroyal');
                }
                break;
            case 'features':
                echo get_the_term_list($post->ID,'property-feature', '', ', ','');
                break;
        }
    }
}
add_action("manage_pages_custom_column", "property_custom_columns");

/*-----------------------------------------------------------------------------------*/
/*	Search support for Property ID on its index page (backend)
/*-----------------------------------------------------------------------------------*/

// Confirm page
function is_prop_index(){
    global $pagenow;
    return ( is_admin() && $pagenow == 'edit.php' && isset($_GET['post_type']) && $_GET['post_type'] == 'property' && isset($_GET['s']) );
}

// Join the Post Meta table
function casaroyal_search_join($join) {
    global $wpdb;
    if ( is_prop_index() ) {
        $join .= ' LEFT JOIN ' . $wpdb->postmeta . ' ON '. $wpdb->posts . '.ID = ' . $wpdb->postmeta . '.post_id ';
    }
    return $join;
}

// Add the Property ID in search
function casaroyal_search_where($where) {
    global $wpdb;
    if (is_prop_index()) {
        $where = preg_replace(
            "/\(\s*".$wpdb->posts.".post_title\s+LIKE\s*(\'[^\']+\')\s*\)/",
            "(".$wpdb->posts.".post_title LIKE $1) OR (".$wpdb->postmeta.".meta_key = 'ft_property_sku') AND (".$wpdb->postmeta.".meta_value LIKE $1)",
            $where );
    }
    return $where;
}

// Group the Properties
function casaroyal_prop_limits($groupby) {
    global $wpdb;
    if (is_prop_index()) { $groupby = "$wpdb->posts.ID"; }
    return $groupby;
}

add_filter( 'posts_join', 'casaroyal_search_join' );
add_filter( 'posts_where', 'casaroyal_search_where' );
add_filter( 'posts_groupby', 'casaroyal_prop_limits' );


/*-----------------------------------------------------------------------------------*/
/*	Comma separated taxonomy terms with admin side links
/*-----------------------------------------------------------------------------------*/
if( ! function_exists ( 'casaroyal_admin_taxonomy_terms' ) ) {
    function casaroyal_admin_taxonomy_terms( $post_id, $taxonomy, $post_type ) {

        $terms = get_the_terms( $post_id, $taxonomy );

        if ( ! empty ( $terms ) ) {
            $out = array();
            /* Loop through each term, linking to the 'edit posts' page for the specific term. */
            foreach ( $terms as $term ) {
                $out[] = sprintf( '<a href="%s">%s</a>',
                    esc_url( add_query_arg( array( 'post_type' => $post_type, $taxonomy => $term->slug ), 'edit.php' ) ),
                    esc_html( sanitize_term_field( 'name', $term->name, $term->term_id, $taxonomy, 'display' ) )
                );
            }
            /* Join the terms, separating them with a comma. */
            return join( ', ', $out );
        }

        return false;
    }
}