<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function sortable_tab_func( $atts, $content = null ) {
    extract(shortcode_atts(array(
        'title'  => '',
        'filter_tag' => '',
    ), $atts));
    global $single_sortable_tab_array;
    $single_sortable_tab_array[] = array(
        'title' => $title, 
        'filter_tag' => $filter_tag,
        'content' => trim(do_shortcode($content))
    );
    return $single_sortable_tab_array;
}
add_shortcode('sortable_tab', 'sortable_tab_func');

vc_map( array(
    'name' => esc_html__( 'Sortable Accordion', 'casaroyal' ),
    'base' => 'sortable_tab',
    'icon' => get_template_directory_uri().'/images/vc-icon.png',
    'description' => esc_html__( 'Custom casaroyal sortable accordion content', 'casaroyal' ),
    "content_element" => true,
    "as_child" => array('only' => 'sortable_tabs'), 
    'params' => array(
        array(
            'type' => 'textfield',
            'heading' => esc_html__( 'Title', 'casaroyal' ),
            'param_name' => 'title',
            'value' => '',
            'admin_label' => true,
            'description' => esc_html__( 'Enter title.', 'casaroyal' ),
        ),
        array(
            'type' => 'textfield',
            'heading' => esc_html__( 'Filter Tag', 'casaroyal' ),
            'param_name' => 'filter_tag',
            'value' => '',
            'admin_label' => true,
        ),
        array(
            'type' => 'textarea_html',
            'heading' => esc_html__( 'Content', 'casaroyal' ),
            'param_name' => 'content',
            'value' => '',
            'group' => esc_html__( 'Content', 'casaroyal' ),
        ),
    ),
));

if ( class_exists( 'WPBakeryShortCode' ) ) {
    class WPBakeryShortCode_sortable_tab extends WPBakeryShortCode {
    }
}

