<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_accordion_item_func( $atts, $content ) {

    extract( shortcode_atts( array(
        "title" => "Section",
        'add_icon' => '',
        'icon_type' => 'fontawesome',
        'icon_fontawesome' => '',
        'icon_openiconic' => '',
        'icon_typicons' => '',
        'icon_entypo' => '',
        'icon_linecons' => '',
        'icon_monosocial' => '',
        'css' => '',
    ), $atts ) );

    ob_start();

    $class_to_filter = '';
    $class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' );
    $css_class = $class_to_filter;

    $icon_class = "";
    $icon_content = "";

    if ( 'true' === $add_icon ) {
        
        vc_icon_element_fonts_enqueue( $icon_type );

        if ( isset( ${'icon_' . $icon_type} ) ) {
            $icon_class = ${'icon_' . $icon_type};
        } else {
            $icon_class = 'fa fa-adjust';
        }

        $icon_content = '<i class="' . wp_kses($icon_class, true) . '"></i>';

    }

    ?>
    
    <li>
        <h4>
            <?php echo wp_kses($icon_content, true); ?><?php echo esc_attr($title); ?>
            <i class="accordion-arrows"></i>
        </h4>
        <div class="casaroyal-accordion-content"><div class="casaroyal-accordion-content-inside"><?php echo wp_kses($content, true); ?></div></div>
    </li>

    <?php

    return ob_get_clean();

}
add_shortcode( 'casaroyal_accordion_item', 'casaroyal_accordion_item_func' );

vc_map( array(
    'name' => esc_html__( 'Accordion Content', 'casaroyal' ),
    'base' => 'casaroyal_accordion_item',
    'icon' => get_template_directory_uri().'/images/vc-icon.png',
    'description' => esc_html__( 'Custom casaroyal accordion content', 'casaroyal' ),
    "content_element" => true,
    "as_child" => array('only' => 'casaroyal_accordion'), 
    'params' => array(
        array(
            'type' => 'textfield',
            'heading' => esc_html__( 'Title', 'casaroyal' ),
            'param_name' => 'title',
            'value' => '',
            'admin_label' => true,
            'description' => esc_html__( 'Enter title.', 'casaroyal' ),
            'group' => esc_html__( 'Title', 'casaroyal' ),
        ),
        array(
            'type' => 'checkbox',
            'heading' => esc_html__( 'Add icon?', 'casaroyal' ),
            'param_name' => 'add_icon',
            'group' => esc_html__( 'Title', 'casaroyal' ),
        ),
        array(
            'type' => 'dropdown',
            'heading' => esc_html__( 'Icon library', 'casaroyal' ),
            'value' => array(
                esc_html__( 'Font Awesome', 'casaroyal' ) => 'fontawesome',
                esc_html__( 'Open Iconic', 'casaroyal' ) => 'openiconic',
                esc_html__( 'Typicons', 'casaroyal' ) => 'typicons',
                esc_html__( 'Entypo', 'casaroyal' ) => 'entypo',
                esc_html__( 'Linecons', 'casaroyal' ) => 'linecons',
                esc_html__( 'Mono Social', 'casaroyal' ) => 'monosocial',
            ),
            'param_name' => 'icon_type',
            'description' => esc_html__( 'Select icon library.', 'casaroyal' ),
            'dependency' => array(
                'element' => 'add_icon',
                'value' => 'true',
            ),
            'std' => 'fontawesome',
            'group' => esc_html__( 'Title', 'casaroyal' ),
        ),
        array(
            'type' => 'iconpicker',
            'heading' => esc_html__( 'Icon', 'casaroyal' ),
            'param_name' => 'icon_fontawesome',
            'value' => 'fa fa-info-circle',
            'settings' => array(
                'emptyIcon' => false,
                // default true, display an "EMPTY" icon?
                'iconsPerPage' => 4000,
                // default 100, how many icons per/page to display
            ),
            'dependency' => array(
                'element' => 'icon_type',
                'value' => 'fontawesome',
            ),
            'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
            'std' => 'fa fa-info-circle',
            'group' => esc_html__( 'Title', 'casaroyal' ),
        ),
        array(
            'type' => 'iconpicker',
            'heading' => esc_html__( 'Icon', 'casaroyal' ),
            'param_name' => 'icon_openiconic',
            'settings' => array(
                'emptyIcon' => false,
                // default true, display an "EMPTY" icon?
                'type' => 'openiconic',
                'iconsPerPage' => 4000,
                // default 100, how many icons per/page to display
            ),
            'dependency' => array(
                'element' => 'icon_type',
                'value' => 'openiconic',
            ),
            'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
            'group' => esc_html__( 'Title', 'casaroyal' ),
        ),
        array(
            'type' => 'iconpicker',
            'heading' => esc_html__( 'Icon', 'casaroyal' ),
            'param_name' => 'icon_typicons',
            'settings' => array(
                'emptyIcon' => false,
                // default true, display an "EMPTY" icon?
                'type' => 'typicons',
                'iconsPerPage' => 4000,
                // default 100, how many icons per/page to display
            ),
            'dependency' => array(
                'element' => 'icon_type',
                'value' => 'typicons',
            ),
            'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
            'group' => esc_html__( 'Title', 'casaroyal' ),
        ),
        array(
            'type' => 'iconpicker',
            'heading' => esc_html__( 'Icon', 'casaroyal' ),
            'param_name' => 'icon_entypo',
            'settings' => array(
                'emptyIcon' => false,
                // default true, display an "EMPTY" icon?
                'type' => 'entypo',
                'iconsPerPage' => 4000,
                // default 100, how many icons per/page to display
            ),
            'dependency' => array(
                'element' => 'icon_type',
                'value' => 'entypo',
            ),
            'group' => esc_html__( 'Title', 'casaroyal' ),
        ),
        array(
            'type' => 'iconpicker',
            'heading' => esc_html__( 'Icon', 'casaroyal' ),
            'param_name' => 'icon_linecons',
            'settings' => array(
                'emptyIcon' => false,
                // default true, display an "EMPTY" icon?
                'type' => 'linecons',
                'iconsPerPage' => 4000,
                // default 100, how many icons per/page to display
            ),
            'dependency' => array(
                'element' => 'icon_type',
                'value' => 'linecons',
            ),
            'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
            'group' => esc_html__( 'Title', 'casaroyal' ),
        ),
        array(
            'type' => 'iconpicker',
            'heading' => esc_html__( 'Icon', 'casaroyal' ),
            'param_name' => 'icon_monosocial',
            'value' => 'vc-mono vc-mono-fivehundredpx', // default value to backend editor admin_label
            'settings' => array(
                'emptyIcon' => false, // default true, display an "EMPTY" icon?
                'type' => 'monosocial',
                'iconsPerPage' => 4000, // default 100, how many icons per/page to display
            ),
            'dependency' => array(
                'element' => 'icon_type',
                'value' => 'monosocial',
            ),
            'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
            'group' => esc_html__( 'Title', 'casaroyal' ),
        ),
        array(
            'type' => 'textarea_html',
            'heading' => esc_html__( 'Content', 'casaroyal' ),
            'param_name' => 'content',
            'value' => '',
            'group' => esc_html__( 'Content', 'casaroyal' ),
        ),
    ),
));

if ( class_exists( 'WPBakeryShortCode' ) ) {
    class WPBakeryShortCode_casaroyal_accordion_item extends WPBakeryShortCode {
    }
}

