<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function sortable_tabs_func( $atts, $content = null ) {

    extract( shortcode_atts( array(
        "css" => "",
    ), $atts ) );

    global $single_sortable_tab_array;
    $single_sortable_tab_array = array(); // clear the array
   
    $sortable_tabs_nav = '';
    $sortable_tabs_content = '';
    $sortable_tabs_output = '';

    $class_to_filter = '';
    $class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' );
    $css_class = $class_to_filter;
 
    $sortable_tabs_nav .= '<div class="casaroyal-sortable-accordion '.$css_class.'"><ul id="filters" class="casaroyal-sortable-accordion-filter"><li class="active" data-filter="*">Show All</li>';
   
    // execute the '[tab]' shortcode first to get the title and content - acts on global $single_tab_array
    do_shortcode($content);

    $filters = array();
   
    //declare our vars to be super clean here
    foreach ($single_sortable_tab_array as $tab => $tab_attr_array) {
        
        $filters[] = $tab_attr_array['filter_tag'];
        $sortable_tabs_content .= '<li class="casaroyal-sortable-accordion-item filter-tag-' . $tab_attr_array['filter_tag'] . '"><h4>'.$tab_attr_array['title'].'</h4><div class="casaroyal-accordion-content"><div class="casaroyal-accordion-content-inside">'.$tab_attr_array['content'].'</div></div></li>';

      
    }
    foreach (array_unique($filters) as $filter_id) {

        $sortable_tabs_nav .= '<li data-filter=".filter-tag-' . $filter_id . '" class="">' . $filter_id . '</li>';
        
    }
    $sortable_tabs_nav .= '</ul><!-- .tab-me-sortable_tabs -->';
    $sortable_tabs_output = $sortable_tabs_nav . '<ul class="casaroyal-accordion masonry-sortable-accordion">' . $sortable_tabs_content . '</ul>';
    $sortable_tabs_output .= '</div><!-- .sortable_tabs-wrapper -->';
    return $sortable_tabs_output;
}
add_shortcode('sortable_tabs', 'sortable_tabs_func');

vc_map( array(
    'name' => esc_html__( 'Sortable Accordions', 'casaroyal' ),
    'base' => 'sortable_tabs',
    'icon' => get_template_directory_uri().'/images/vc-icon.png',
    'description' => esc_html__( 'Custom casaroyal accordion', 'casaroyal' ),
    "as_parent" => array('only' => 'sortable_tab'), // Use only|except attributes to limit child shortcodes (separate multiple values with comma)
    "content_element" => true,
    "show_settings_on_create" => false,
    "is_container" => true,
    'params' => array(
        array(
            'type' => 'css_editor',
            'heading' => esc_html__( 'CSS box', 'casaroyal' ),
            'param_name' => 'css',
            'group' => esc_html__( 'Design Options', 'casaroyal' ),
        ),
    ),
    "js_view" => 'VcColumnView'
));

//Your "container" content element should extend WPBakeryShortCodesContainer class to inherit all required functionality
if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
    class WPBakeryShortCode_sortable_tabs extends WPBakeryShortCodesContainer {
    }
}

