<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_accordion_func( $atts, $content = null ) {

    extract( shortcode_atts( array(
        "css" => "",
    ), $atts ) );

    ob_start();

    $class_to_filter = '';
    $class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' );
    $css_class = $class_to_filter;

    // Establish the Accent Color
    $casaroyal_main_color = "";
    if(!empty($accent_color)) {
        $casaroyal_main_color = $accent_color;
    }

    ?>

    <ul class="casaroyal-accordion <?php echo esc_attr($css_class); ?>">

        <?php echo do_shortcode($content); ?>

    </div>

    <?php

    return ob_get_clean();

}
add_shortcode( 'casaroyal_accordion', 'casaroyal_accordion_func' );

vc_map( array(
    'name' => esc_html__( 'Accordion', 'casaroyal' ),
    'base' => 'casaroyal_accordion',
    'icon' => get_template_directory_uri().'/images/vc-icon.png',
    'description' => esc_html__( 'Custom casaroyal accordion', 'casaroyal' ),
    "as_parent" => array('only' => 'casaroyal_accordion_item'), // Use only|except attributes to limit child shortcodes (separate multiple values with comma)
    "content_element" => true,
    "show_settings_on_create" => false,
    "is_container" => true,
    'params' => array(
        array(
            'type' => 'css_editor',
            'heading' => esc_html__( 'CSS box', 'casaroyal' ),
            'param_name' => 'css',
            'group' => esc_html__( 'Design Options', 'casaroyal' ),
        ),
    ),
    "js_view" => 'VcColumnView'
));

//Your "container" content element should extend WPBakeryShortCodesContainer class to inherit all required functionality
if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
    class WPBakeryShortCode_casaroyal_accordion extends WPBakeryShortCodesContainer {
    }
}

