<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_agents_func( $atts ) {

	extract( shortcode_atts( array(
    	"css" => "",
   	), $atts ) );

	ob_start();

	$class_to_filter = '';
	$class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

    $MODS = get_theme_mods();
    foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

    // Scroll Animation
    $scroll_animation;
    if(strlen($MODS['scroll_animation'])>0) {
        $scroll_animation = $MODS['scroll_animation'];
    }
    //

	?>

	<div class="agent-wrapper <?php echo esc_attr($css_class); ?> <?php if($scroll_animation == "on") { ?>aos-init<?php } ?>" <?php if($scroll_animation == "on") { ?>data-aos="fade-left" data-aos-delay="300"<?php } ?>>

		<div class='owl-demo owl-carousel owl-theme owl-agents masonry-projects'>

			<?php 

		  		$wp_query_project = null;
				$wp_query_project = new WP_Query();
				$wp_query_project->query('post_type=agent&posts_per_page=-1');

			?>
			<?php if ( $wp_query_project->have_posts() ) : ?>
				
				<?php while ($wp_query_project->have_posts()) : $wp_query_project->the_post(); ?>

					<!-- post -->
					<div id="post-<?php the_ID(); ?>" class="item item-agent">

						<div class="item-agent-container">

							<div class="casaroyal-search-card">

                                <div class="casaroyal-search-card-body blog-card-body">

                                    <div class="casaroyal-search-card-image">

                                        <?php if ( has_post_thumbnail() ) { $large_image_url = wp_get_attachment_image_src( get_post_thumbnail_id(), 'large' ); ?>

                                            <a href="<?php the_permalink(); ?>" title="<?php the_title_attribute(); ?>">
                                                
                                                <?php the_post_thumbnail( "casaroyal-property-list-view-image" ); ?>

                                                <div class="project-hover-overlay">
                                                    <span></span>
                                                    <span></span>
                                                    <span></span>
                                                </div>
                                                
                                            </a>

                                        <?php } ?>

                                    </div>

                                    <div class="entry-title">

                                        <?php $agent_position = get_post_meta(get_the_ID(), 'ft_agent_position',true); if(!empty($agent_position)) { ?>
                                        
                                            <span class="casaroyal-agent-position"><?php echo esc_attr($agent_position); ?></span>

                                        <?php } ?>

                                    </div>

                                    <h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>

                                    <div class="entry-title agent-contacts">

                                        <?php $agent_mobile = get_post_meta(get_the_ID(), 'ft_mobile_number',true); if(!empty($agent_mobile)) { ?>

                                            <h5><i class="fa fa-phone" aria-hidden="true"></i> <a href="tel:<?php echo esc_attr($agent_mobile); ?>"><?php echo esc_attr($agent_mobile); ?></a></h5>

                                        <?php } ?>

                                        <?php $agent_email = get_post_meta(get_the_ID(), 'ft_agent_email',true); if(!empty($agent_email)) { ?>

                                            <h5><i class="fa fa-envelope" aria-hidden="true"></i> <a href="mailto:<?php echo esc_attr($agent_email); ?>"><?php echo esc_attr($agent_email); ?></a></h5>

                                        <?php } ?>
                                            
                                    </div>

                                    <?php
                                        $facebook_url = get_post_meta(get_the_ID(), 'ft_facebook_url',true);
                                        $twitter_url = get_post_meta(get_the_ID(), 'ft_twitter_url',true);
                                        $linked_in_url = get_post_meta(get_the_ID(), 'ft_linked_in_url',true);

                                        if(!empty($facebook_url) || !empty($twitter_url) || !empty($linked_in_url)){
                                            ?>
                                            <!-- Agent's Social Navigation -->
                                            <ul class="casaroyal-agent-social-links agent-social-link clearfix">
                                                <?php
                                                if(!empty($facebook_url)){
                                                    ?>
                                                    <li class="facebook">
                                                        <a target="_blank" href="<?php echo esc_url($facebook_url); ?>"><i class="fa fa-facebook fa-lg"></i></a>
                                                    </li>
                                                <?php
                                                }
                                                if(!empty($twitter_url)){
                                                    ?>
                                                    <li class="twitter">
                                                        <a target="_blank" href="<?php echo esc_url($twitter_url); ?>" ><i class="fa fa-twitter fa-lg"></i></a>
                                                    </li>
                                                <?php
                                                }
                                                if(!empty($linked_in_url)){
                                                    ?>
                                                    <li class="linkedin">
                                                        <a target="_blank" href="<?php echo esc_url($linked_in_url); ?>"><i class="fa fa-linkedin fa-lg"></i></a>
                                                    </li>
                                                <?php
                                                }
                                                ?>
                                            </ul>
                                        <?php
                                        }
                                    ?>

                                </div>

                            </div>

						</div>

					</div>
					<!-- /post -->
		    			        		            
		        <?php endwhile; ?>

			<?php endif; wp_reset_postdata(); ?>

        </div>

	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_agents', 'casaroyal_agents_func' );

vc_map( array(
  	'name' => esc_html__( 'Agents', 'casaroyal' ),
	'base' => 'casaroyal_agents',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal agents', 'casaroyal' ),
	'params' => array(
        array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

