<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_animated_number_box_func( $atts, $content ) {

	extract( shortcode_atts( array(
		'title' => 'Title',
		'prenumber' => '',
		'afternumber' => '',
		'number' => '99',
		'custom_color' => '#c63730',
		'box_style' => 'default',
    	'use_theme_fonts' => '',
    	'google_fonts' => '',
    	'google_fonts_data' => '',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$google_fonts_field = $google_fonts;
	$font_container = '';
	$font_container_field = '';

	$font_container_obj = new Vc_Font_Container();
	$google_fonts_obj = new Vc_Google_Fonts();
	$font_container_field_settings = isset( $font_container_field['settings'], $font_container_field['settings']['fields'] ) ? $font_container_field['settings']['fields'] : array();
	$google_fonts_field_settings = isset( $google_fonts_field['settings'], $google_fonts_field['settings']['fields'] ) ? $google_fonts_field['settings']['fields'] : array();
	$font_container_data = $font_container_obj->_vc_font_container_parse_attributes( $font_container_field_settings, $font_container );
	$google_fonts_data = strlen( $google_fonts ) > 0 ? $google_fonts_obj->_vc_google_fonts_parse_attributes( $google_fonts_field_settings, $google_fonts ) : '';

	$styles = array();
	if ( ! empty( $font_container_data ) && isset( $font_container_data['values'] ) ) {
		foreach ( $font_container_data['values'] as $key => $value ) {
			if ( 'tag' !== $key && strlen( $value ) ) {
				if ( preg_match( '/description/', $key ) ) {
					continue;
				}
				if ( 'font_size' === $key || 'line_height' === $key ) {
					$value = preg_replace( '/\s+/', '', $value );
				}
				if ( 'font_size' === $key ) {
					$pattern = '/^(\d*(?:\.\d+)?)\s*(px|\%|in|cm|mm|em|rem|ex|pt|pc|vw|vh|vmin|vmax)?$/';
					// allowed metrics: http://www.w3schools.com/cssref/css_units.asp
					$regexr = preg_match( $pattern, $value, $matches );
					$value = isset( $matches[1] ) ? (float) $matches[1] : (float) $value;
					$unit = isset( $matches[2] ) ? $matches[2] : 'px';
					$value = $value . $unit;
				}
				if ( strlen( $value ) > 0 ) {
					$styles[] = str_replace( '_', '-', $key ) . ': ' . $value;
				}
			}
		}
	}
	if ( ( ! isset( $atts['use_theme_fonts'] ) || 'yes' !== $atts['use_theme_fonts'] ) && ! empty( $google_fonts_data ) && isset( $google_fonts_data['values'], $google_fonts_data['values']['font_family'], $google_fonts_data['values']['font_style'] ) ) {
		$google_fonts_family = explode( ':', $google_fonts_data['values']['font_family'] );
		$styles[] = 'font-family:' . $google_fonts_family[0];
		$google_fonts_styles = explode( ':', $google_fonts_data['values']['font_style'] );
		$styles[] = 'font-weight:' . $google_fonts_styles[1];
		$styles[] = 'font-style:' . $google_fonts_styles[2];
	}

	$settings = get_option( 'wpb_js_google_fonts_subsets' );
	if ( is_array( $settings ) && ! empty( $settings ) ) {
		$subsets = '&subset=' . implode( ',', $settings );
	} else {
		$subsets = '';
	}

	if ( isset( $google_fonts_data['values']['font_family'] ) ) {
		wp_enqueue_style( 'vc_google_fonts_' . vc_build_safe_css_class( $google_fonts_data['values']['font_family'] ), '//fonts.googleapis.com/css?family=' . $google_fonts_data['values']['font_family'] . $subsets );
	}

	if ( ! empty( $styles ) ) {
		$styles_final = "";
		foreach ($styles as $key => $value) {
			$styles_final .= $value.";";
		}
	}

	$boxed_css = "";
	if ( $box_style == 'boxed' ) {
		$boxed_css = "casaroyal-icon-box-style-boxed";
	} elseif ( $box_style == 'boxed_alt' ) {
		$boxed_css = "casaroyal-icon-box-style-alt";
	} else {
		$boxed_css = "casaroyal-icon-box-style-default";
	}

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	?>

	<div class="casaroyal-animated-number-box <?php echo esc_attr($boxed_css); ?> <?php echo esc_attr($css_class); ?>">
	
		<h1 style="color: <?php echo esc_attr($custom_color); ?>;"><?php if(!empty($prenumber)) { echo esc_attr($prenumber); } ?><span class="count"><?php echo esc_attr($number); ?></span><?php if(!empty($afternumber)) { echo esc_attr($afternumber); } ?></h1>
		<h3 style="<?php echo esc_attr($styles_final); ?>"><?php echo esc_attr($title); ?></h3>

	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_animated_number_box', 'casaroyal_animated_number_box_func' );

vc_map( array(
  	'name' => esc_html__( 'Animated Number', 'casaroyal' ),
	'base' => 'casaroyal_animated_number_box',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal icon box', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Number', 'casaroyal' ),
			'param_name' => 'number',
			'admin_label' => true,
			'value' => esc_html__( '99', 'casaroyal' ),
			'group' => esc_html__( 'Content', 'casaroyal' ),
		),
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Pre-Number', 'casaroyal' ),
			'param_name' => 'prenumber',
			'value' => esc_html__( ' ', 'casaroyal' ),
			'group' => esc_html__( 'Content', 'casaroyal' ),
		),
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'After Number', 'casaroyal' ),
			'param_name' => 'afternumber',
			'value' => esc_html__( ' ', 'casaroyal' ),
			'group' => esc_html__( 'Content', 'casaroyal' ),
		),
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Title', 'casaroyal' ),
			'param_name' => 'title',
			'admin_label' => true,
			'value' => esc_html__( 'Title', 'casaroyal' ),
			'group' => esc_html__( 'Content', 'casaroyal' ),
		),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Box Style', 'casaroyal' ),
			'description' => esc_html__( 'Select button display style.', 'casaroyal' ),
			'param_name' => 'box_style',
			'value' => array(
				__( 'Default', 'casaroyal' ) => 'default',
				__( 'Boxed', 'casaroyal' ) => 'boxed',
				__( 'Boxed Alt', 'casaroyal' ) => 'boxed_alt',
			),
			'std' => 'default',
			'group' => esc_html__( 'Content', 'casaroyal' ),
		),
		array(
			'type' => 'checkbox',
			'heading' => esc_html__( 'Use title theme default font family?', 'casaroyal' ),
			'param_name' => 'use_theme_fonts',
			'value' => array( esc_html__( 'Yes', 'casaroyal' ) => 'yes' ),
			'description' => esc_html__( 'Use font family from the theme.', 'casaroyal' ),
			'std' => 'yes',
			'group' => esc_html__( 'Content', 'casaroyal' ),
		),
		array(
			'type' => 'google_fonts',
			'param_name' => 'google_fonts',
			'value' => 'font_family:Abril%20Fatface%3Aregular|font_style:400%20regular%3A400%3Anormal',
			'settings' => array(
				'fields' => array(
					'font_family_description' => esc_html__( 'Select font family.', 'casaroyal' ),
					'font_style_description' => esc_html__( 'Select font styling.', 'casaroyal' ),
				),
			),
			'dependency' => array(
				'element' => 'use_theme_fonts',
				'value_not_equal_to' => 'yes',
			),
			'std' => 'font_family:Abril%20Fatface%3Aregular|font_style:400%20regular%3A400%3Anormal',
			'group' => esc_html__( 'Content', 'casaroyal' ),
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Number Color', 'casaroyal' ),
			'param_name' => 'custom_color',
			'description' => esc_html__( 'Select custom number color for your element.', 'casaroyal' ),
			'std' => '#c63730',
			'group' => esc_html__( 'Content', 'casaroyal' ),
		),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),

));

