<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_banner_func( $atts, $content ) {

	extract( shortcode_atts( array(
    	'link' => '',
    	'height' => '1-1',
    	'image' => '',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$img_id = preg_replace( '/[^\d]/', '', $image );
	$link_image = wp_get_attachment_image_src( $img_id, 'large' );
	$img_src = $link_image[0];

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	?>

	<div class="casaroyal-banner casaroyal-banner-height-layout-<?php if(!empty($height)) { echo esc_attr($height); } ?>" <?php if(!empty($link)) { ?> onclick="window.location.href='<?php echo esc_attr($link); ?>'" <?php } ?>>
		<div class="casaroyal-banner-image" style="background-image: url(<?php echo esc_url($img_src); ?>);" ></div>
		<div class="casaroyal-banner-content <?php echo esc_attr($css_class); ?>"><?php echo wp_kses($content, true); ?></div>
			
	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_banner', 'casaroyal_banner_func' );

vc_map( array(
  	'name' => esc_html__( 'Banner', 'casaroyal' ),
	'base' => 'casaroyal_banner',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal banner', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'textarea_html',
			'heading' => esc_html__( 'Text', 'casaroyal' ),
			'param_name' => 'content',
			'value' => '',
			"group" => "Content",
		),
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Link', 'casaroyal' ),
			'param_name' => 'link',
			'value' => '',
			'description' => esc_html__( 'Enter the banner link.', 'casaroyal' ),
			"group" => "Settings",
		),
		array(
            "type" => "dropdown",
            "class" => "",
            "heading" => esc_html__("Height", "casaroyal"),
            "param_name" => "height",
            'admin_label' => true,
            "value" => array( esc_html__("Auto", "casaroyal") => "auto", esc_html__("1/1", "casaroyal") => "1-1", esc_html__("1/2", "casaroyal") => "1-2"),
            "std" => "1-1",
            "group" => "Settings",
        ),
		array(
			'type' => 'attach_image',
			'heading' => esc_html__( 'Background Image', 'casaroyal' ),
			'param_name' => 'image',
			'value' => '',
			'description' => esc_html__( 'Select image from media library.', 'casaroyal' ),
			"group" => "Settings",
		),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

