<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_blog_posts_func( $atts ) {

	extract( shortcode_atts( array(
        "columns" => "three",
    	"css" => "",
   	), $atts ) );

	ob_start();

    $class_to_filter = '';
    $class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' );
    $css_class = $class_to_filter;

    $MODS = get_theme_mods();
    foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

    // Scroll Animation
    $scroll_animation;
    if(strlen($MODS['scroll_animation'])>0) {
        $scroll_animation = $MODS['scroll_animation'];
    }
    //

   	?>

   	<div class="casaroyal-blog-posts-shortcode <?php echo esc_attr($css_class); ?>">
            
        <?php 

            $columns_number = 3;
            if($columns == "two") {
                $columns_number = 2;
            }

            $wp_query_project = null;
            $wp_query_project = new WP_Query();
            $wp_query_project->query('post_type=post&posts_per_page='.$columns_number);

            $current = 0;

        ?>
        <?php if ( $wp_query_project->have_posts() ) : ?>
                    
            <div class="row">
                
                <?php while ($wp_query_project->have_posts()) : $wp_query_project->the_post(); $current++; ?>

                    <!-- post -->
                    <div id="post-<?php the_ID(); ?>" <?php if($columns == "two") { post_class('col-md-6 aos-animate'); } else { post_class('col-md-4 aos-animate'); } ?> <?php if($scroll_animation == "on") { ?>data-aos="fade-up" data-aos-delay="<?php echo esc_attr( $current * 100); ?>"<?php } ?>>

                        <div class="casaroyal-search-card">

                            <?php 

                                if(get_post_format() == "link") {

                                ?>

                                <div class="casaroyal-search-card-image">

                                    <?php $link = get_post_meta( get_the_ID(),'_td_link_url',true ); if(!empty($link)) { ?>
                                        <a href="<?php echo esc_url($link); ?>" class="casaroyal-search-card-link"><?php echo esc_url($link); ?></a>
                                    <?php } ?>

                                </div>

                                <?php

                                } elseif(get_post_format() == "video") {

                                ?>

                                <div class="casaroyal-search-card-image">

                                    <?php $video = get_post_meta( get_the_ID(),'_td_video_embed_code',true ); if(!empty($video)) { echo $video;  } ?>

                                </div>

                                <?php

                                } elseif(get_post_format() == "image") {

                                ?>

                                <?php 

                                    if(has_post_thumbnail()) {

                                        $image_src = wp_get_attachment_image_src( get_post_thumbnail_id( get_the_ID() ), 'casaroyal-post-shortcode', false, '' ); 
                                        $td_title_bg_img = esc_url($image_src[0]);

                                    } 

                                ?>

                                <?php if(!empty($td_title_bg_img)) { ?>

                                    <div class="casaroyal-search-card-image casaroyal-post-card-image">

                                        <a href="<?php echo esc_url(get_permalink( get_the_ID() )); ?>">
                                            <span></span>
                                            <span></span>
                                            <span></span>
                                            <div class="mask"></div>
                                            <img src="<?php echo esc_url($td_title_bg_img_post); ?>"  />
                                        </a>

                                    </div>

                                <?php } ?>

                                <?php

                                } elseif(get_post_format() == "quote") {

                                ?>

                                <div class="casaroyal-search-card-image">
            
                                    <div class="casaroyal-search-card-quote">

                                        <?php $QUOTE_text = get_post_meta( get_the_ID(),'_td_quote',true ); if(!empty($QUOTE_text)) { ?>
                                            <h2 class="post-title"><?php echo esc_attr($QUOTE_text); ?></h2>
                                        <?php } ?>
                                        <?php $QUOTE_author = get_post_meta( get_the_ID(),'_td_quote_author',true ); if(!empty($QUOTE_author)) { ?>
                                            <p class="post-date"><b>- <?php echo esc_attr($QUOTE_author); ?></b></p>
                                        <?php } ?>

                                    </div>

                                </div>

                                <?php

                                } elseif(get_post_format() == "gallery") {

                                ?>

                                <div class="casaroyal-search-card-image">
    
                                    <div class="flexslider">
                                        <ul class="slides">
                                            <?php
                                                $attachments = get_children(array('post_parent' => get_the_ID(),
                                                                                'post_status' => 'inherit',
                                                                                'post_type' => 'attachment',
                                                                                'post_mime_type' => 'image',
                                                                                'order' => 'ASC',
                                                                                'orderby' => 'menu_order ID'));

                                                foreach($attachments as $att_id => $attachment) {
                                                        
                                                    $medium_img_urls = wp_get_attachment_image_src( $attachment->ID, 'full' );
                                            ?>

                                                <li class="casaroyal-flexslider-bg-image" style="background-image: url(<?php echo esc_url($medium_img_urls[0]); ?>);"></li>

                                            <?php
                                                }
                                            ?>
                                        </ul>
                                    </div>

                                </div>

                                <?php

                                } else {

                                ?>

                                <?php 

                                    if(has_post_thumbnail()) {
 
                                        $image_src = wp_get_attachment_image_src( get_post_thumbnail_id( get_the_ID() ), 'casaroyal-post-shortcode', false, '' ); 
                                        $td_title_bg_img_post = esc_url($image_src[0]);

                                    } 

                                ?>

                                <?php if(!empty($td_title_bg_img_post)) { ?>

                                    <div class="casaroyal-search-card-image casaroyal-post-card-image">

                                        <a href="<?php echo esc_url(get_permalink( get_the_ID() )); ?>">
                                            <span></span>
                                            <span></span>
                                            <span></span>
                                            <div class="mask"></div>
                                            <img src="<?php echo esc_url($td_title_bg_img_post); ?>"  />
                                        </a>

                                    </div>

                                <?php } ?>

                                <?php

                                }

                            ?>

                            <div class="casaroyal-search-card-body blog-card-body">

                                <div class="casaroyal-categories-post"><?php the_category(' '); ?></div>

                                <h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>

                                <?php if ( is_sticky() ) : ?>
        
                                    <a href="<?php the_permalink(); ?>" title="<?php esc_attr_e('Sticky post','casaroyal') ?>" class="sticky-post">
                                        <div class="genericon genericon-star"><i class="fa fa-star" aria-hidden="true"></i></div>
                                    </a>
                                
                                <?php endif; ?>

                                <span class="casaroyal-search-card-body-meta">
                                        
                                    <span class="post-meta-item">
                                        <span class="post-meta-icon"><?php get_template_part( 'images/post/clock.svg' ); ?></span> <a href="<?php the_permalink(); ?>"><?php the_time(get_option('date_format')); ?></a>
                                    </span>

                                </span>

                            </div>

                        </div>

                    </div>
                    <!-- /post -->
                                                    
                <?php endwhile; ?>
                            
            </div> <!-- /posts -->
    
        <?php endif; wp_reset_postdata(); ?>

    </div> <!-- /content -->

    <?php

    return ob_get_clean();

}
add_shortcode( 'casaroyal_blog_posts', 'casaroyal_blog_posts_func' );

vc_map( array(
  	'name' => esc_html__( 'Blog Posts', 'casaroyal' ),
	'base' => 'casaroyal_blog_posts',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal blog posts', 'casaroyal' ),
	'params' => array(
        array(
            'type' => 'dropdown',
            'heading' => esc_html__( 'Columns', 'casaroyal' ),
            'description' => esc_html__( 'Select columns amount.', 'casaroyal' ),
            'param_name' => 'columns',
            'value' => array(
                esc_html__( 'Three', 'casaroyal' ) => 'three',
                esc_html__( 'Two', 'casaroyal' ) => 'two',
            ),
            'std' => 'three',
            'group' => esc_html__( 'General', 'casaroyal' ),
        ),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

?>