<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_button_video_default_func( $atts, $content ) {

	extract( shortcode_atts( array(
    	'link' => 'https://vimeo.com/51589652',
    	'align' => '',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	?>

	<a href="<?php echo esc_url( $link ); ?>" rel="prettyPhoto"  style="float: <?php if($align != "center") { echo esc_attr($align); } ?>"><span class="video-play-icon"></span></a>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_button_video_default', 'casaroyal_button_video_default_func' );

vc_map( array(
  	'name' => esc_html__( 'Video Button (Default)', 'casaroyal' ),
	'base' => 'casaroyal_button_video_default',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal banner', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Video link', 'casaroyal' ),
			'param_name' => 'link',
			'value' => 'https://vimeo.com/51589652',
			'admin_label' => true,
			'description' => sprintf( esc_html__( 'Enter link to video (Note: read more about available formats at WordPress <a href="%s" target="_blank">codex page</a>).', 'casaroyal' ), 'http://codex.wordpress.org/Embeds#Okay.2C_So_What_Sites_Can_I_Embed_From.3F' ),
		),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Alignment', 'casaroyal' ),
			'param_name' => 'align',
			'description' => esc_html__( 'Select button alignment.', 'casaroyal' ),
			// compatible with btn2, default left to be compatible with btn1
			'value' => array(
				__( 'Center', 'casaroyal' ) => 'center',
				__( 'Left', 'casaroyal' ) => 'left',
				__( 'Right', 'casaroyal' ) => 'right',
			),
			'std' => 'center',
		),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),

));

