<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_button_func( $atts, $content ) {

	extract( shortcode_atts( array(
		'title' => '',
    	'link' => '',
    	'use_theme_fonts' => '',
    	'google_fonts' => 'font_family:Abril%20Fatface%3Aregular|font_style:400%20regular%3A400%3Anormal',
    	'google_fonts_data' => '',
    	'add_icon' => '',
    	'icon_type' => 'fontawesome',
    	'icon_fontawesome' => '',
		'icon_openiconic' => '',
		'icon_typicons' => '',
		'icon_entypo' => '',
		'icon_linecons' => '',
		'icon_monosocial' => '',
		'align' => 'inline',
		'i_align' => 'left',
		'style' => 'default',
		'radius' => '100px',
		'custom_background_color' => '',
		'custom_text_color' => '',
		'custom_background_color_hover' => '',
		'custom_text_color_hover' => '',
		'outline_custom_color' => '',
		'outline_custom_hover_background' => '',
		'outline_custom_hover_text' => '',
		'button_size' => 'large',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$google_fonts_field = $google_fonts;
	$font_container = '';
	$font_container_field = '';

	$font_container_obj = new Vc_Font_Container();
	$google_fonts_obj = new Vc_Google_Fonts();
	$font_container_field_settings = isset( $font_container_field['settings'], $font_container_field['settings']['fields'] ) ? $font_container_field['settings']['fields'] : array();
	$google_fonts_field_settings = isset( $google_fonts_field['settings'], $google_fonts_field['settings']['fields'] ) ? $google_fonts_field['settings']['fields'] : array();
	$font_container_data = $font_container_obj->_vc_font_container_parse_attributes( $font_container_field_settings, $font_container );
	$google_fonts_data = strlen( $google_fonts ) > 0 ? $google_fonts_obj->_vc_google_fonts_parse_attributes( $google_fonts_field_settings, $google_fonts ) : '';

	$styles = array();
	if ( ! empty( $font_container_data ) && isset( $font_container_data['values'] ) ) {
		foreach ( $font_container_data['values'] as $key => $value ) {
			if ( 'tag' !== $key && strlen( $value ) ) {
				if ( preg_match( '/description/', $key ) ) {
					continue;
				}
				if ( 'font_size' === $key || 'line_height' === $key ) {
					$value = preg_replace( '/\s+/', '', $value );
				}
				if ( 'font_size' === $key ) {
					$pattern = '/^(\d*(?:\.\d+)?)\s*(px|\%|in|cm|mm|em|rem|ex|pt|pc|vw|vh|vmin|vmax)?$/';
					// allowed metrics: http://www.w3schools.com/cssref/css_units.asp
					$regexr = preg_match( $pattern, $value, $matches );
					$value = isset( $matches[1] ) ? (float) $matches[1] : (float) $value;
					$unit = isset( $matches[2] ) ? $matches[2] : 'px';
					$value = $value . $unit;
				}
				if ( strlen( $value ) > 0 ) {
					$styles[] = str_replace( '_', '-', $key ) . ': ' . $value;
				}
			}
		}
	}
	if ( ( ! isset( $atts['use_theme_fonts'] ) || 'yes' !== $atts['use_theme_fonts'] ) && ! empty( $google_fonts_data ) && isset( $google_fonts_data['values'], $google_fonts_data['values']['font_family'], $google_fonts_data['values']['font_style'] ) ) {
		$google_fonts_family = explode( ':', $google_fonts_data['values']['font_family'] );
		$styles[] = 'font-family:' . $google_fonts_family[0];
		$google_fonts_styles = explode( ':', $google_fonts_data['values']['font_style'] );
		$styles[] = 'font-weight:' . $google_fonts_styles[1];
		$styles[] = 'font-style:' . $google_fonts_styles[2];
	}

	$settings = get_option( 'wpb_js_google_fonts_subsets' );
	if ( is_array( $settings ) && ! empty( $settings ) ) {
		$subsets = '&subset=' . implode( ',', $settings );
	} else {
		$subsets = '';
	}

	if ( isset( $google_fonts_data['values']['font_family'] ) ) {
		wp_enqueue_style( 'vc_google_fonts_' . vc_build_safe_css_class( $google_fonts_data['values']['font_family'] ), '//fonts.googleapis.com/css?family=' . $google_fonts_data['values']['font_family'] . $subsets );
	}

	if ( ! empty( $styles ) ) {
		$styles_final = "";
		foreach ($styles as $key => $value) {
			$styles_final .= $value.";";
		}
	}

	$link = ( '||' === $link ) ? '' : $link;
	$link = vc_build_link( $link );
	$a_href = $link['url'];
	$a_title = $link['title'];
	$a_target = $link['target'];
	$a_rel = $link['rel'];
	if ( ! empty( $a_rel ) ) {
		$a_rel = ' rel="' . esc_attr( trim( $a_rel ) ) . '"';
	}

	if ( 'true' === $add_icon ) {
		vc_icon_element_fonts_enqueue( $icon_type );

		if ( isset( ${'icon_' . $icon_type} ) ) {
			$icon_class = ${'icon_' . $icon_type};
		} else {
			$icon_class = 'fa fa-adjust';
		}
	}

	$onmouseenter = "";
	if(!empty($custom_text_color_hover) AND $style == "custom") { 
		$onmouseenter .= "this.style.color='".$custom_text_color_hover."';";
	}

	if(!empty($custom_background_color_hover) AND $style == "custom") {
		$onmouseenter .= "this.style.backgroundColor='".$custom_background_color_hover."';";
	}

	if(!empty($outline_custom_color) AND $style == "custom_outline") {
		$onmouseenter .= "this.style.color='".$outline_custom_color."';";
		$onmouseenter .= "this.style.borderColor='".$outline_custom_color."';";
	}

	if(!empty($outline_custom_hover_background) AND $style == "custom_outline") {
		$onmouseenter .= "this.style.backgroundColor='".$outline_custom_hover_background."';";
	}

	if(!empty($outline_custom_hover_text) AND $style == "custom_outline") {
		$onmouseenter .= "this.style.color='".$outline_custom_hover_text."';";
	}

	$onmouseleave = "";
	if(!empty($custom_text_color) AND $style == "custom") { 
		$onmouseleave .= "this.style.color='".$custom_text_color."';";
	} 

	if(!empty($custom_background_color) AND $style == "custom") { 
		$onmouseleave .= "this.style.backgroundColor='".$custom_background_color."';";
	}

	if(!empty($outline_custom_color) AND $style == "custom_outline") {
		$onmouseleave .= "this.style.color='".$outline_custom_color."';";
		$onmouseleave .= "this.style.borderColor='".$outline_custom_color."';";
	}

	if(!empty($outline_custom_hover_background) AND $style == "custom_outline") {
		$onmouseleave .= "this.style.backgroundColor='transparent';";
	}

	$custom_style = "";
	if($style == "custom_outline") { 
		$custom_style .= "background-color: transparent; border-color: ".$outline_custom_color."; color: ".$outline_custom_color."; "; 
	} 

	if(!empty($custom_background_color)) { 
		$custom_style .= "background-color: ".$custom_background_color."; "; 
	} 

	if(!empty($custom_background_color)) { 
		$custom_style .= "color: ".$custom_text_color."; "; 
	} 

	if(!empty($radius)) { 
		$custom_style .= "border-radius: ".$radius."; "; 
	}

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	$MODS = get_theme_mods();
    foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

    // Scroll Animation
    $scroll_animation;
    if(strlen($MODS['scroll_animation'])>0) {
        $scroll_animation = $MODS['scroll_animation'];
    }
    //

	?>

	<div class="casaroyal-button-container casaroyal-button-align-<?php echo esc_attr($align); ?> casaroyal-button-icon-align-<?php echo esc_attr($i_align); ?> casaroyal-button-style-<?php echo esc_attr($style); ?> casaroyal-button-size-<?php echo esc_attr($button_size); ?> <?php echo esc_attr($css_class); ?> <?php if($scroll_animation == "on") { ?>aos-init<?php } ?>" <?php if($scroll_animation == "on") { ?>data-aos="zoom-in"<?php } ?>>
		<a class="btn-casaroyal" onmouseenter="<?php echo esc_attr($onmouseenter); ?>" onmouseleave="<?php echo esc_attr($onmouseleave); ?>" href="<?php echo esc_url( $a_href ); ?>" target="<?php echo esc_attr( $a_target ); ?>" title="<?php echo esc_attr( $title ); ?>" style="<?php echo esc_attr($custom_style); echo esc_attr($styles_final); ?>" ><?php if ( 'true' === $add_icon ) { if($i_align != "right") { echo "<i class='" . wp_kses($icon_class, true) . "'></i>"; } } ?><?php echo esc_attr($title); ?><?php if ( 'true' === $add_icon ) { if($i_align == "right") { echo "<i class='" . wp_kses($icon_class, true) . "'></i>"; } } ?></a>
	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_button', 'casaroyal_button_func' );

vc_map( array(
  	'name' => esc_html__( 'Button', 'casaroyal' ),
	'base' => 'casaroyal_button',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal banner', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Text', 'casaroyal' ),
			'param_name' => 'title',
			'admin_label' => true,
			'value' => esc_html__( 'Text on the button', 'casaroyal' ),
		),
		array(
			'type' => 'vc_link',
			'heading' => esc_html__( 'URL (Link)', 'casaroyal' ),
			'param_name' => 'link',
			'description' => esc_html__( 'Add link to button.', 'casaroyal' ),
		),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Style', 'casaroyal' ),
			'description' => esc_html__( 'Select button display style.', 'casaroyal' ),
			'param_name' => 'style',
			'value' => array(
				__( 'Default', 'casaroyal' ) => 'default',
				__( 'Light', 'casaroyal' ) => 'light',
				__( 'Outline', 'casaroyal' ) => 'default_outline',
				__( 'Outline Light', 'casaroyal' ) => 'outline_light',
				__( 'Custom', 'casaroyal' ) => 'custom',
				__( 'Custom Outline', 'casaroyal' ) => 'custom_outline',
			),
			'std' => 'default',
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Background', 'casaroyal' ),
			'param_name' => 'custom_background_color',
			'description' => esc_html__( 'Select custom background color for your element.', 'casaroyal' ),
			'dependency' => array(
				'element' => 'style',
				'value' => array( 'custom' ),
			),
			'edit_field_class' => 'vc_col-sm-6',
			'std' => '#000000',
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Text', 'casaroyal' ),
			'param_name' => 'custom_text_color',
			'description' => esc_html__( 'Select custom text color for your element.', 'casaroyal' ),
			'dependency' => array(
				'element' => 'style',
				'value' => array( 'custom' ),
			),
			'edit_field_class' => 'vc_col-sm-6',
			'std' => '#2a41e8',
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Hover Background', 'casaroyal' ),
			'param_name' => 'custom_background_color_hover',
			'description' => esc_html__( 'Select custom background color for your element.', 'casaroyal' ),
			'dependency' => array(
				'element' => 'style',
				'value' => array( 'custom' ),
			),
			'edit_field_class' => 'vc_col-sm-6',
			'std' => '#000000',
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Hover Text', 'casaroyal' ),
			'param_name' => 'custom_text_color_hover',
			'description' => esc_html__( 'Select custom text color for your element.', 'casaroyal' ),
			'dependency' => array(
				'element' => 'style',
				'value' => array( 'custom' ),
			),
			'edit_field_class' => 'vc_col-sm-6',
			'std' => '#2a41e8',
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Outline and Text', 'casaroyal' ),
			'param_name' => 'outline_custom_color',
			'description' => esc_html__( 'Select outline and text color for your element.', 'casaroyal' ),
			'dependency' => array(
				'element' => 'style',
				'value' => array( 'custom_outline' ),
			),
			'edit_field_class' => 'vc_col-sm-4',
			'std' => '#2a41e8',
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Hover background', 'casaroyal' ),
			'param_name' => 'outline_custom_hover_background',
			'description' => esc_html__( 'Select hover background color for your element.', 'casaroyal' ),
			'dependency' => array(
				'element' => 'style',
				'value' => array( 'custom_outline' ),
			),
			'edit_field_class' => 'vc_col-sm-4',
			'std' => '#666',
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Hover text', 'casaroyal' ),
			'param_name' => 'outline_custom_hover_text',
			'description' => esc_html__( 'Select hover text color for your element.', 'casaroyal' ),
			'dependency' => array(
				'element' => 'style',
				'value' => array( 'custom_outline' ),
			),
			'edit_field_class' => 'vc_col-sm-4',
			'std' => '#fff',
		),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Alignment', 'casaroyal' ),
			'param_name' => 'align',
			'description' => esc_html__( 'Select button alignment.', 'casaroyal' ),
			// compatible with btn2, default left to be compatible with btn1
			'value' => array(
				__( 'Inline', 'casaroyal' ) => 'inline',
				__( 'Left', 'casaroyal' ) => 'left',
				__( 'Right', 'casaroyal' ) => 'right',
				__( 'Center', 'casaroyal' ) => 'center',
			),
			'std' => 'inline',
		),
		array(
			'type' => 'checkbox',
			'heading' => esc_html__( 'Use theme default font family?', 'casaroyal' ),
			'param_name' => 'use_theme_fonts',
			'value' => array( esc_html__( 'Yes', 'casaroyal' ) => 'yes' ),
			'description' => esc_html__( 'Use font family from the theme.', 'casaroyal' ),
		),
		array(
			'type' => 'google_fonts',
			'param_name' => 'google_fonts',
			'value' => 'font_family:Abril%20Fatface%3Aregular|font_style:400%20regular%3A400%3Anormal',
			'settings' => array(
				'fields' => array(
					'font_family_description' => esc_html__( 'Select font family.', 'casaroyal' ),
					'font_style_description' => esc_html__( 'Select font styling.', 'casaroyal' ),
				),
			),
			'dependency' => array(
				'element' => 'use_theme_fonts',
				'value_not_equal_to' => 'yes',
			),
			'std' => 'font_family:Abril%20Fatface%3Aregular|font_style:400%20regular%3A400%3Anormal',
		),
		array(
			'type' => 'checkbox',
			'heading' => esc_html__( 'Add icon?', 'casaroyal' ),
			'param_name' => 'add_icon',
		),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Icon Alignment', 'casaroyal' ),
			'description' => esc_html__( 'Select icon alignment.', 'casaroyal' ),
			'param_name' => 'i_align',
			'value' => array(
				__( 'Left', 'casaroyal' ) => 'left',
				__( 'Right', 'casaroyal' ) => 'right',
			),
			'dependency' => array(
				'element' => 'add_icon',
				'value' => 'true',
			),
			'std' => 'left',
		),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Icon library', 'casaroyal' ),
			'value' => array(
				__( 'Font Awesome', 'casaroyal' ) => 'fontawesome',
				__( 'Open Iconic', 'casaroyal' ) => 'openiconic',
				__( 'Typicons', 'casaroyal' ) => 'typicons',
				__( 'Entypo', 'casaroyal' ) => 'entypo',
				__( 'Linecons', 'casaroyal' ) => 'linecons',
				__( 'Mono Social', 'casaroyal' ) => 'monosocial',
			),
			'param_name' => 'icon_type',
			'description' => esc_html__( 'Select icon library.', 'casaroyal' ),
			'dependency' => array(
				'element' => 'add_icon',
				'value' => 'true',
			),
			'std' => 'fontawesome',
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_fontawesome',
			'value' => 'fa fa-info-circle',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'fontawesome',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
			'std' => 'fa fa-info-circle',
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_openiconic',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'type' => 'openiconic',
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'openiconic',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_typicons',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'type' => 'typicons',
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'typicons',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_entypo',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'type' => 'entypo',
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'entypo',
			),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_linecons',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'type' => 'linecons',
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'linecons',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_monosocial',
			'value' => 'vc-mono vc-mono-fivehundredpx', // default value to backend editor admin_label
			'settings' => array(
				'emptyIcon' => false, // default true, display an "EMPTY" icon?
				'type' => 'monosocial',
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'monosocial',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
		),
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Border Radius', 'casaroyal' ),
			'param_name' => 'radius',
			'value' => esc_html__( '100px', 'casaroyal' ),
			'description' => esc_html__( 'Use px or %.', 'casaroyal' ),
			'std' => '100px',
		),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Size', 'casaroyal' ),
			'description' => esc_html__( 'Select button size.', 'casaroyal' ),
			'param_name' => 'button_size',
			'value' => array(
				__( 'Large', 'casaroyal' ) => 'large',
				__( 'Medium', 'casaroyal' ) => 'medium',
				__( 'Small', 'casaroyal' ) => 'small',
			),
			'std' => 'large',
		),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),

));

