<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_entry_title_func( $atts, $content ) {

	extract( shortcode_atts( array(
		'title' => 'Title',
		'title_color' => '#111111',
		'pretitle' => '',
		'pre_title_color' => '#8c8c8c',
		'align' => 'left',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$class_to_filter = '';
    $class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' );
    $css_class = $class_to_filter;

	$MODS = get_theme_mods();
    foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

    // Scroll Animation
    $scroll_animation;
    if(strlen($MODS['scroll_animation'])>0) {
        $scroll_animation = $MODS['scroll_animation'];
    }
    //

	?>

	<div class="casaroyal-entry-title-wrapper <?php echo esc_attr($css_class); ?> <?php if($scroll_animation == "on") { ?>aos-init<?php } ?>" <?php if($scroll_animation == "on") { ?>data-aos="fade-up"<?php } ?>>
		<div class="casaroyal-entry-title casaroyal-entry-title-align-<?php echo esc_attr($align); ?>">
	     	<?php if(!empty($pretitle)) { ?><h5 style="color: <?php echo esc_attr($pre_title_color); ?>"><?php echo esc_attr($pretitle); ?></h5><?php } ?>
			<?php if(!empty($title)) { ?><h3 style="color: <?php echo esc_attr($title_color); ?>"><?php echo esc_attr($title); ?></h3><?php } ?>
		</div>
    </div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_entry_title', 'casaroyal_entry_title_func' );

vc_map( array(
  	'name' => esc_html__( 'Entry Title', 'casaroyal' ),
	'base' => 'casaroyal_entry_title',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal entry title', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Pre-Title', 'casaroyal' ),
			'param_name' => 'pretitle',
			'admin_label' => true,
			'value' => esc_html__( 'Pre-Title', 'casaroyal' ),
		),
		array(
            'type' => 'colorpicker',
            'heading' => esc_html__( 'Pre-Title Color', 'casaroyal' ),
            'param_name' => 'pre_title_color',
            'description' => esc_html__( 'Select color for pre title.', 'casaroyal' ),
            'std' => '#8c8c8c',
        ),
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Title', 'casaroyal' ),
			'param_name' => 'title',
			'admin_label' => true,
			'value' => esc_html__( 'Title', 'casaroyal' ),
		),
		array(
            'type' => 'colorpicker',
            'heading' => esc_html__( 'Title Color', 'casaroyal' ),
            'param_name' => 'title_color',
            'description' => esc_html__( 'Select color for title.', 'casaroyal' ),
            'std' => '#111111',
        ),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Align', 'casaroyal' ),
			'value' => array(
				__( 'Left', 'casaroyal' ) => 'left',
				__( 'Center', 'casaroyal' ) => 'center',
				__( 'Right', 'casaroyal' ) => 'right',
			),
			'param_name' => 'align',
			'description' => esc_html__( 'Select align.', 'casaroyal' ),
			'std' => 'left',
		),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),

));

