<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_gallery_func( $atts ) {

	$large_img_src = $pretty_rel_random = $gal_images = "";

	extract( shortcode_atts( array(
    	'images' => '',
    	'cover_image' => '',
    	'gallery_style' => '',
    	'gallery_name' => '',
    	'gallery_desc' => '',
    	'gallery_style' => 'default',
    	'gallery_gap' => 'none',
    	'casaroyal_gallery_full_options' => '',
    	'gallery_cover_type' => 'none',
    	'css' => '',
   	), $atts ) );

   	ob_start();

   	$img_id = preg_replace( '/[^\d]/', '', $cover_image );
	$link_image = wp_get_attachment_image_src( $img_id, 'large' );
	$img_src = $link_image[0];

   	if ( '' === $images ) {
		$images = '-1,-2,-3';
	}

	$class_to_filter = 'wpb_gallery vc_clearfix';
	$class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	$images = explode( ',', $images );

	?>

	<div class="<?php echo esc_attr($css_class); ?>">

		<?php if($gallery_style == "fullscreen_slider") { ?>

			<div class="casaroyal-gallery-fullscreen-slider">

		    	<?php 

					$gallery_cover_url = $img_src;
					$gallery_cover_style = $gallery_cover_type;

					if($gallery_cover_style != "none") {

				?>

			    <div class="casaroyal-gallery-fullscreen-slider-cover property-banner <?php if(!empty($gallery_cover_url)) { ?>has-image-bg<?php } ?> <?php if($gallery_cover_style == "centered") { echo "casaroyal-gallery-fullscreen-slider-cover-centered"; } ?>">

			    	<div class="casaroyal-gallery-fullscreen-slider-cover-inner">

			    		<span class="casaroyal-gallery-fullscreen-slider-cover-title"><?php echo esc_attr($gallery_name); ?></span>

			    		<?php if(!empty($gallery_desc)) { ?>
				    	<div class="casaroyal-gallery-fullscreen-slider-cover-subtitle"><?php echo esc_attr($gallery_desc); ?></div>
				    	<?php } ?>

				    	<div class="casaroyal-gallery-fullscreen-slider-cover-open-gallery">
							<span class="cover-open-gallery-text"><?php esc_html_e('View Gallery','casaroyal'); ?> (<?php echo count($images); ?>)</span>
							<span class="cover-open-gallery-arrow"></span>
				    	</div>

					</div>
			    	
					<?php if(!empty($gallery_cover_url)) { ?><div class="casaroyal-page-title-image-background" <?php if(!empty($gallery_cover_url)) { ?>style="background-image: url(<?php echo esc_url($gallery_cover_url); ?>);"<?php } ?>></div><?php } ?>

			    </div>

			    <?php } ?>
	
				<div class="casaroyal-gallery-fullscreen-slider-flexslider <?php $full_type = get_post_meta($post->ID, 'casaroyal_gallery_full_options',true); if($full_type == "contain") { echo "casaroyal-gallery-fullscreen-slider-contain"; } ?>">

					<ul class="slides" data-images="<?php echo count($images); ?>">

						<?php

							$current_image = 0;

							foreach ( $images as $i => $image ) {

								if ( $image > 0 ) {
									$img = wpb_getImageBySize( array( 'attach_id' => $image ) );
									$large_img_src = $img['p_img_large'][0];
								} else {
									$large_img_src = $default_src;
								}

								$current_image++;

							?>

							<li class="casaroyal-flexslider-bg-image" style="background-image: url(<?php echo esc_url($large_img_src); ?>);" data-current="<?php echo esc_attr($current_image); ?>">

								<div class="casaroyal-gallery-fullscreen-slider-content">

									<div class="casaroyal-gallery-fullscreen-slider-content-title"><?php $attachment_title = get_the_title($image); echo esc_attr($attachment_title); ?></div>

									<?php

										$exif_data = exif_read_data( $large_img_src );

										$image_meta_camera_make   = $exif_data['Make'];
										$image_meta_camera_model  = $exif_data['Model'];
										$image_meta_focal_length  = $exif_data['FocalLengthIn35mmFilm'];
										$image_meta_aperture      = $exif_data['COMPUTED']['ApertureFNumber'];
										$image_meta_iso           = $exif_data['ISOSpeedRatings'];
										$image_meta_shutter_speed = $exif_data['COMPUTED']['ExposureTime'];

									?>

									<div class="image_meta_wrapper">

										<?php if( !empty($image_meta_camera_make) OR !empty($image_meta_camera_model) ) { ?><div class="image_meta_camera">Camera <?php echo esc_attr($image_meta_camera_make); ?> <?php echo esc_attr($image_meta_camera_model); ?></div><?php } ?>
										<?php if( !empty($image_meta_focal_length) ) { ?><div class="image_meta_focal_length">Focal Length <?php echo esc_attr($image_meta_focal_length); ?>mm</div><?php } ?>
										<?php if( !empty($image_meta_aperture) ) { ?><div class="image_meta_aperture">Aperture <?php echo esc_attr($image_meta_aperture); ?></div><?php } ?>
										<?php if( !empty($image_meta_iso) ) { ?><div class="image_meta_iso">ISO <?php echo esc_attr($image_meta_iso); ?></div><?php } ?>
										<?php if( !empty($image_meta_shutter_speed) ) { ?><div class="image_meta_shutter_speed">Shutter Speed <?php echo esc_attr($image_meta_shutter_speed); ?></div><?php } ?>

									</div>

								</div>

							</li>

						<?php } ?>

					</ul>

				</div>

			</div>

		<?php } else { ?> 

			<div class="wpb_wrapper col-md-12">

				<div class="image-gallery <?php if($gallery_style == "masonry") { echo "image-gallery-masonry"; } ?> <?php if($gallery_gap != "none") { echo "image-gallery-gap-"; echo esc_attr($gallery_gap); } else { echo "image-gallery-no-gap"; } ?>">

					<?php

						foreach ( $images as $i => $image ) {

							if ( $image > 0 ) {
								$img = wpb_getImageBySize( array( 'attach_id' => $image ) );
								$large_img_src = $img['p_img_large'][0];
							} else {
								$large_img_src = $default_src;
							}

						?>

							<div class="<?php if($gallery_style == "masonry") { echo "gallery-item-masonry"; } elseif($gallery_style == "thumbnails") { echo "gallery-item-thumnails"; } elseif($gallery_style == "casaroyal") { echo "gallery-item-casaroyal"; } else { echo "gallery-item"; } ?>">
								
								<?php if($gallery_style == "masonry") { ?>

								<a data-lightbox="gallery" href="<?php echo esc_url($large_img_src); ?>" <?php echo esc_attr($pretty_rel_random); ?>><img src="<?php echo esc_url($large_img_src); ?>" ></a>

								<?php } else { ?>

								<a data-lightbox="gallery" href="<?php echo esc_url($large_img_src); ?>" <?php echo esc_attr($pretty_rel_random); ?> style="background-image: url(<?php echo esc_url($large_img_src); ?>"></a>

								<?php } ?>

							</div>

						<?php

						}

					?>

				</div>

			</div>

		<?php } ?>

	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_gallery', 'casaroyal_gallery_func' );

vc_map( array(
  	'name' => esc_html__( 'Gallery', 'casaroyal' ),
	'base' => 'casaroyal_gallery',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal gallery', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'attach_images',
			'heading' => esc_html__( 'Images', 'casaroyal' ),
			'param_name' => 'images',
			'value' => '',
			'description' => esc_html__( 'Select images from media library.', 'casaroyal' ),
			'group' => esc_html__( 'Content', 'casaroyal' ),
		),
		array(
            'type' => 'dropdown',
            'heading' => esc_html__( 'Gallery Style', 'casaroyal' ),
            'description' => esc_html__( 'Select gallery style.', 'casaroyal' ),
            'param_name' => 'gallery_style',
            'value' => array(
                esc_html__( 'Default', 'casaroyal' ) => 'default',
                esc_html__( 'Fullscreen Slider', 'casaroyal' ) => 'fullscreen_slider',
                esc_html__( 'Thumbnails', 'casaroyal' ) => 'thumbnails',
                esc_html__( 'Masonry', 'casaroyal' ) => 'masonry',
                esc_html__( 'casaroyal Style', 'casaroyal' ) => 'casaroyal',
            ),
            'std' => 'default',
            "admin_label" => true,
            'group' => esc_html__( 'Settings', 'casaroyal' ),
        ),
        array(
            "type" => "textfield",
            "class" => "",
            "heading" => esc_html__("Gallery name", "casaroyal"),
            "param_name" => "gallery_name",
            "admin_label" => true,
            "value" => "",
            'dependency' => array(
				'element' => 'gallery_style',
				'value' => array( 'fullscreen_slider' ),
			),
			'group' => esc_html__( 'Settings', 'casaroyal' ),
        ),
        array(
            "type" => "textarea",
            "class" => "",
            "heading" => esc_html__("Gallery description", "casaroyal"),
            "param_name" => "gallery_desc",
            "value" => "",
            'dependency' => array(
				'element' => 'gallery_style',
				'value' => array( 'fullscreen_slider' ),
			),
			'group' => esc_html__( 'Settings', 'casaroyal' ),
        ),
        array(
			'type' => 'attach_images',
			'heading' => esc_html__( 'Gallery cover image', 'casaroyal' ),
			'param_name' => 'cover_image',
			'value' => '',
			'description' => esc_html__( 'Select image from media library.', 'casaroyal' ),
			'dependency' => array(
				'element' => 'gallery_style',
				'value' => array( 'fullscreen_slider' ),
			),
			'group' => esc_html__( 'Settings', 'casaroyal' ),
		),
		array(
            'type' => 'dropdown',
            'heading' => esc_html__( 'Gallery cover type', 'casaroyal' ),
            'description' => esc_html__( 'Select gallery cover type.', 'casaroyal' ),
            'param_name' => 'gallery_cover_type',
            'value' => array(
                esc_html__( 'None', 'casaroyal' ) => 'none',
                esc_html__( 'Center Aligned Title', 'casaroyal' ) => 'centered',
                esc_html__( 'Left Aligned Title', 'casaroyal' ) => 'left',
            ),
            'dependency' => array(
				'element' => 'gallery_style',
				'value' => array( 'fullscreen_slider' ),
			),
            'std' => 'none',
            'group' => esc_html__( 'Settings', 'casaroyal' ),
        ),
        array(
            'type' => 'dropdown',
            'heading' => esc_html__( 'Fullscreen Slider Image Options', 'casaroyal' ),
            'param_name' => 'casaroyal_gallery_full_options',
            'value' => array(
                esc_html__( 'Fullscreen', 'casaroyal' ) => 'fullscreen',
                esc_html__( 'Contain (no crop)', 'casaroyal' ) => 'contain',
            ),
            'dependency' => array(
				'element' => 'gallery_style',
				'value' => array( 'fullscreen_slider' ),
			),
            'std' => 'none',
            'group' => esc_html__( 'Settings', 'casaroyal' ),
        ),
        array(
            'type' => 'dropdown',
            'heading' => esc_html__( 'Gap', 'casaroyal' ),
            'description' => esc_html__( 'Select gap between images.', 'casaroyal' ),
            'param_name' => 'gallery_gap',
            'value' => array(
                esc_html__( 'None', 'casaroyal' ) => 'none',
                esc_html__( '10px', 'casaroyal' ) => '10',
                esc_html__( '20px', 'casaroyal' ) => '20',
                esc_html__( '30px', 'casaroyal' ) => '30',
            ),
            'dependency' => array(
				'element' => 'gallery_style',
				'value' => array( 'default', 'thumbnails', 'masonry', 'casaroyal' ),
			),
            'std' => 'none',
            'group' => esc_html__( 'Settings', 'casaroyal' ),
        ),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

