<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_icon_box_func( $atts, $content ) {

	extract( shortcode_atts( array(
		'title' => 'Box Title',
		'style' => 'default',
		'icon_bg_color' => '#f55a4e',
		'box_style' => 'default',
		'animation_delay' => '0',
    	'use_theme_fonts' => '',
    	'google_fonts' => '',
    	'google_fonts_data' => '',
    	'add_icon' => '',
    	'icon_type' => 'fontawesome',
    	'icon_fontawesome' => '',
		'icon_openiconic' => '',
		'icon_typicons' => '',
		'icon_entypo' => '',
		'icon_linecons' => '',
		'icon_monosocial' => '',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$google_fonts_field = $google_fonts;
	$font_container = '';
	$font_container_field = '';

	$font_container_obj = new Vc_Font_Container();
	$google_fonts_obj = new Vc_Google_Fonts();
	$font_container_field_settings = isset( $font_container_field['settings'], $font_container_field['settings']['fields'] ) ? $font_container_field['settings']['fields'] : array();
	$google_fonts_field_settings = isset( $google_fonts_field['settings'], $google_fonts_field['settings']['fields'] ) ? $google_fonts_field['settings']['fields'] : array();
	$font_container_data = $font_container_obj->_vc_font_container_parse_attributes( $font_container_field_settings, $font_container );
	$google_fonts_data = strlen( $google_fonts ) > 0 ? $google_fonts_obj->_vc_google_fonts_parse_attributes( $google_fonts_field_settings, $google_fonts ) : '';

	$styles = array();
	if ( ! empty( $font_container_data ) && isset( $font_container_data['values'] ) ) {
		foreach ( $font_container_data['values'] as $key => $value ) {
			if ( 'tag' !== $key && strlen( $value ) ) {
				if ( preg_match( '/description/', $key ) ) {
					continue;
				}
				if ( 'font_size' === $key || 'line_height' === $key ) {
					$value = preg_replace( '/\s+/', '', $value );
				}
				if ( 'font_size' === $key ) {
					$pattern = '/^(\d*(?:\.\d+)?)\s*(px|\%|in|cm|mm|em|rem|ex|pt|pc|vw|vh|vmin|vmax)?$/';
					// allowed metrics: http://www.w3schools.com/cssref/css_units.asp
					$regexr = preg_match( $pattern, $value, $matches );
					$value = isset( $matches[1] ) ? (float) $matches[1] : (float) $value;
					$unit = isset( $matches[2] ) ? $matches[2] : 'px';
					$value = $value . $unit;
				}
				if ( strlen( $value ) > 0 ) {
					$styles[] = str_replace( '_', '-', $key ) . ': ' . $value;
				}
			}
		}
	}
	if ( ( ! isset( $atts['use_theme_fonts'] ) || 'yes' !== $atts['use_theme_fonts'] ) && ! empty( $google_fonts_data ) && isset( $google_fonts_data['values'], $google_fonts_data['values']['font_family'], $google_fonts_data['values']['font_style'] ) ) {
		$google_fonts_family = explode( ':', $google_fonts_data['values']['font_family'] );
		$styles[] = 'font-family:' . $google_fonts_family[0];
		$google_fonts_styles = explode( ':', $google_fonts_data['values']['font_style'] );
		$styles[] = 'font-weight:' . $google_fonts_styles[1];
		$styles[] = 'font-style:' . $google_fonts_styles[2];
	}

	$settings = get_option( 'wpb_js_google_fonts_subsets' );
	if ( is_array( $settings ) && ! empty( $settings ) ) {
		$subsets = '&subset=' . implode( ',', $settings );
	} else {
		$subsets = '';
	}

	if ( isset( $google_fonts_data['values']['font_family'] ) ) {
		wp_enqueue_style( 'vc_google_fonts_' . vc_build_safe_css_class( $google_fonts_data['values']['font_family'] ), '//fonts.googleapis.com/css?family=' . $google_fonts_data['values']['font_family'] . $subsets );
	}

	if ( ! empty( $styles ) ) {
		$styles_final = "";
		foreach ($styles as $key => $value) {
			$styles_final .= $value.";";
		}
	}

	if ( 'true' === $add_icon ) {
		vc_icon_element_fonts_enqueue( $icon_type );

		if ( isset( ${'icon_' . $icon_type} ) ) {
			$icon_class = ${'icon_' . $icon_type};
		} else {
			$icon_class = 'fa fa-adjust';
		}
	}

	$boxed_css = "";
	if ( $box_style == 'boxed' ) {
		$boxed_css = "casaroyal-icon-box-style-boxed";
	} else {
		$boxed_css = "casaroyal-icon-box-style-default";
	}

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	$MODS = get_theme_mods();
    foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

    // Scroll Animation
    $scroll_animation;
    if(strlen($MODS['scroll_animation'])>0) {
        $scroll_animation = $MODS['scroll_animation'];
    }
    //

	?>

	<div class="<?php if($scroll_animation == "on") { ?>aos-init<?php } ?>" <?php if($scroll_animation == "on") { ?>data-aos="fade-up" data-aos-delay="<?php echo esc_attr($animation_delay); ?>"<?php } ?>>

		<?php if( $style == "icon_top" ) { ?>

			<div class="casaroyal-icon-box <?php echo esc_attr($boxed_css); ?> <?php echo esc_attr($css_class); ?>">
		
				<?php if ( 'true' === $add_icon ) { ?>
				<div class="casaroyal-icon-box-icon">
					<?php echo "<i class='" . wp_kses($icon_class, true) . "'></i>"; ?>
				</div>
				<?php } ?>
				<div class="casaroyal-icon-box-content">
					<h4 style="<?php echo esc_attr($styles_final); ?>"><?php echo esc_attr($title); ?></h4>
					<?php echo wp_kses($content, true); ?>
				</div>

			</div>

		<?php } elseif( $style == "icon_top_center" ) { ?>

			<div class="casaroyal-icon-box casaroyal-icon-box-centered <?php echo esc_attr($boxed_css); ?> <?php echo esc_attr($css_class); ?>">

				<?php if ( 'true' === $add_icon ) { ?>
				<div class="casaroyal-icon-box-icon">
					<?php echo "<i class='" . wp_kses($icon_class, true) . "'></i>"; ?>
				</div>
				<?php } ?>
				<div class="casaroyal-icon-box-content">
					<h4 style="<?php echo esc_attr($styles_final); ?>"><?php echo esc_attr($title); ?></h4>
					<?php echo wp_kses($content, true); ?>
				</div>

			</div>

		<?php } elseif( $style == "icon_top_center_alt" ) { ?>

			<div class="casaroyal-icon-box casaroyal-icon-box-centered-alt <?php echo esc_attr($boxed_css); ?> <?php echo esc_attr($css_class); ?>">

				<?php if ( 'true' === $add_icon ) { ?>
				<div class="casaroyal-icon-box-icon">
					<?php echo "<i class='" . wp_kses($icon_class, true) . "' style='background-color: " . esc_attr($icon_bg_color) . "'></i>"; ?>
				</div>
				<?php } ?>
				<div class="casaroyal-icon-box-content">
					<h4 style="<?php echo esc_attr($styles_final); ?>"><?php echo esc_attr($title); ?></h4>
					<?php echo wp_kses($content, true); ?>
				</div>

			</div>

		<?php } elseif( $style == "icon_side" ) { ?>

			<div class="casaroyal-icon-box casaroyal-icon-box-side <?php echo esc_attr($boxed_css); ?> <?php echo esc_attr($css_class); ?>">

				<?php if ( 'true' === $add_icon ) { ?>
				<div class="casaroyal-icon-box-icon">
					<?php echo "<i class='" . wp_kses($icon_class, true) . "'></i>"; ?>
				</div>
				<?php } ?>
				<div class="casaroyal-icon-box-content">
					<h4 style="<?php echo esc_attr($styles_final); ?>"><?php echo esc_attr($title); ?></h4>
					<?php echo wp_kses($content, true); ?>
				</div>

			</div>

		<?php } else { ?>

			<div class="casaroyal-icon-box <?php echo esc_attr($boxed_css); ?> <?php echo esc_attr($css_class); ?>">

				<div class="casaroyal-icon-box-content">
					<h4 style="<?php echo esc_attr($styles_final); ?>">
						<?php if ( 'true' === $add_icon ) { echo "<i class='" . wp_kses($icon_class, true) . "'></i>"; } ?>
						<?php echo esc_attr($title); ?>
					</h4>
					<?php echo wp_kses($content, true); ?>
				</div>

			</div>

		<?php } ?>

	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_icon_box', 'casaroyal_icon_box_func' );

vc_map( array(
  	'name' => esc_html__( 'Icon Box', 'casaroyal' ),
	'base' => 'casaroyal_icon_box',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal icon box', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Title', 'casaroyal' ),
			'param_name' => 'title',
			'admin_label' => true,
			'value' => esc_html__( 'Box Title', 'casaroyal' ),
			'group' => esc_html__( 'Content', 'casaroyal' ),
		),
		array(
			'type' => 'textarea_html',
			'heading' => esc_html__( 'Content', 'casaroyal' ),
			'param_name' => 'content',
			'value' => '',
			'group' => esc_html__( 'Content', 'casaroyal' ),
		),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Style', 'casaroyal' ),
			'description' => esc_html__( 'Select button display style.', 'casaroyal' ),
			'param_name' => 'style',
			'value' => array(
				__( 'Default', 'casaroyal' ) => 'default',
				__( 'Icon Top', 'casaroyal' ) => 'icon_top',
				__( 'Icon Top Center', 'casaroyal' ) => 'icon_top_center',
				__( 'Icon Top Center Alt', 'casaroyal' ) => 'icon_top_center_alt',
				__( 'Side Icon', 'casaroyal' ) => 'icon_side',
			),
			'std' => 'default',
			'group' => esc_html__( 'Style', 'casaroyal' ),
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Icon Alternative Background Color', 'casaroyal' ),
			'param_name' => 'icon_bg_color',
			'description' => esc_html__( 'Select color for icon background.', 'casaroyal' ),
			'dependency' => array(
				'element' => 'style',
				'value' => array( 'icon_top_center_alt' ),
			),
			'group' => esc_html__( 'Style', 'casaroyal' ),
			'std' => '#f55a4e',
		),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Box Style', 'casaroyal' ),
			'description' => esc_html__( 'Select button display style.', 'casaroyal' ),
			'param_name' => 'box_style',
			'value' => array(
				__( 'Default', 'casaroyal' ) => 'default',
				__( 'Boxed', 'casaroyal' ) => 'boxed',
			),
			'std' => 'default',
			'group' => esc_html__( 'Style', 'casaroyal' ),
		),
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Animation delay', 'casaroyal' ),
			'param_name' => 'animation_delay',
			'admin_label' => true,
			'value' => esc_html__( '0', 'casaroyal' ),
			'group' => esc_html__( 'Style', 'casaroyal' ),
		),
		array(
			'type' => 'checkbox',
			'heading' => esc_html__( 'Use title theme default font family?', 'casaroyal' ),
			'param_name' => 'use_theme_fonts',
			'value' => array( esc_html__( 'Yes', 'casaroyal' ) => 'yes' ),
			'description' => esc_html__( 'Use font family from the theme.', 'casaroyal' ),
			'std' => 'yes',
			'group' => esc_html__( 'Style', 'casaroyal' ),
		),
		array(
			'type' => 'google_fonts',
			'param_name' => 'google_fonts',
			'value' => 'font_family:Abril%20Fatface%3Aregular|font_style:400%20regular%3A400%3Anormal',
			'settings' => array(
				'fields' => array(
					'font_family_description' => esc_html__( 'Select font family.', 'casaroyal' ),
					'font_style_description' => esc_html__( 'Select font styling.', 'casaroyal' ),
				),
			),
			'dependency' => array(
				'element' => 'use_theme_fonts',
				'value_not_equal_to' => 'yes',
			),
			'std' => 'font_family:Abril%20Fatface%3Aregular|font_style:400%20regular%3A400%3Anormal',
			'group' => esc_html__( 'Style', 'casaroyal' ),
		),
		array(
			'type' => 'checkbox',
			'heading' => esc_html__( 'Add icon?', 'casaroyal' ),
			'param_name' => 'add_icon',
			'group' => esc_html__( 'Icon', 'casaroyal' ),
			'std' => 'false',
		),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Icon library', 'casaroyal' ),
			'value' => array(
				__( 'Font Awesome', 'casaroyal' ) => 'fontawesome',
				__( 'Open Iconic', 'casaroyal' ) => 'openiconic',
				__( 'Typicons', 'casaroyal' ) => 'typicons',
				__( 'Entypo', 'casaroyal' ) => 'entypo',
				__( 'Linecons', 'casaroyal' ) => 'linecons',
				__( 'Mono Social', 'casaroyal' ) => 'monosocial',
			),
			'param_name' => 'icon_type',
			'description' => esc_html__( 'Select icon library.', 'casaroyal' ),
			'dependency' => array(
				'element' => 'add_icon',
				'value' => 'true',
			),
			'std' => 'fontawesome',
			'group' => esc_html__( 'Icon', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_fontawesome',
			'value' => 'fa fa-info-circle',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'fontawesome',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
			'std' => 'fa fa-info-circle',
			'group' => esc_html__( 'Icon', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_openiconic',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'type' => 'openiconic',
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'openiconic',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
			'group' => esc_html__( 'Icon', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_typicons',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'type' => 'typicons',
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'typicons',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
			'group' => esc_html__( 'Icon', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_entypo',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'type' => 'entypo',
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'entypo',
			),
			'group' => esc_html__( 'Icon', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_linecons',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'type' => 'linecons',
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'linecons',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
			'group' => esc_html__( 'Icon', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_monosocial',
			'value' => 'vc-mono vc-mono-fivehundredpx', // default value to backend editor admin_label
			'settings' => array(
				'emptyIcon' => false, // default true, display an "EMPTY" icon?
				'type' => 'monosocial',
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'monosocial',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
			'group' => esc_html__( 'Icon', 'casaroyal' ),
		),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),

));

