<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_partners_func( $atts, $content ) {

	extract( shortcode_atts( array(
		"style" => "version_1",
    	'css' => '',
   	), $atts ) );

	ob_start();

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	?>

	<div class=" <?php echo esc_attr($css_class); ?>">

		<?php if($style == "version_2") { ?>

			<div class="row">

	            <?php 

	                global $custom_posts2;
	                $custom_posts2 = new WP_Query();
	                $custom_posts2->query('post_type=partners&posts_per_page=-1&post_status=publish');

	                if ( $custom_posts2->have_posts() ) {

	                  while ($custom_posts2->have_posts()) : $custom_posts2->the_post();

	                  $author_id = get_the_ID();

	                  $partner_url = get_post_meta(get_the_ID(), 'casaroyal_partner_url',true);

	            ?>

	            <div class='col-md-3 col-sm-6 col-xs-1'>

	            	<div class="casaroyal-search-card partners-grid-version">

		            	<a class="casaroyal-search-card-body" href="<?php echo esc_url($partner_url); ?>">

			                <?php

			                	if(has_post_thumbnail(get_the_ID())){
				                    the_post_thumbnail( 'full' );
				                }

			                ?>

		               	</a>

		            </div>

	            </div>

	            <?php endwhile; ?>

	            <?php } wp_reset_postdata(); ?>

	        </div>

		<?php } else { ?>

			<div class='owl-demo owl-carousel owl-theme owl-partners'>

	            <?php 

	                global $custom_posts2;
	                $custom_posts2 = new WP_Query();
	                $custom_posts2->query('post_type=partners&posts_per_page=-1&post_status=publish');

	                if ( $custom_posts2->have_posts() ) {

	                  while ($custom_posts2->have_posts()) : $custom_posts2->the_post();

	                  $author_id = get_the_ID();

	                  $partner_url = get_post_meta(get_the_ID(), 'casaroyal_partner_url',true);

	            ?>

	            <div class='item'>

	            	<a href="<?php echo esc_url($partner_url); ?>">

		                <?php

		                	if(has_post_thumbnail(get_the_ID())){
			                    the_post_thumbnail( 'full' );
			                }

		                ?>

	               	</a>

	            </div>

	            <?php endwhile; ?>

	            <?php } wp_reset_postdata(); ?>

	        </div>

        <?php } ?>
			
	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_partners', 'casaroyal_partners_func' );

vc_map( array(
  	'name' => esc_html__( 'Partners', 'casaroyal' ),
	'base' => 'casaroyal_partners',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal banner', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Style', 'casaroyal' ),
			'param_name' => 'style',
			'description' => esc_html__( 'Select partners style.', 'casaroyal' ),
			'value' => array(
				__( 'Version 1', 'casaroyal' ) => 'version_1',
				__( 'Version 2', 'casaroyal' ) => 'version_2',
			),
			'std' => 'version_1',
		),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

