<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_progress_bar_func( $atts ) {

	extract( shortcode_atts( array(
        "title" => "",
        "stroke_color" => "#f55a4e",
        "percentage" => "33",
        "animated_bg" => "",
    	"css" => "",
   	), $atts ) );

	ob_start();

	$class_to_filter = '';
	$class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

    $circle_percentage = ($percentage * 629)/100;

	?>
    
    <div class="casaroyal-progress-bar-thick">
        
        <div class="casaroyal-progress-bar-holder">

            <div class="casaroyal-progress-bar-description"><?php if(!empty($title)) { echo esc_attr($title); } ?></div>
            <div class="casaroyal-progress-bar-content">
                <div class="casaroyal-progress-bar-progress <?php if ( 'true' === $animated_bg ) { echo 'animated-bg'; } ?>" style="background-color: <?php echo esc_attr($stroke_color); ?>;" data-percent="<?php echo esc_attr($percentage); ?>%"></div>
            </div>

        </div>

    </div>

    <?php

    return ob_get_clean();

}
add_shortcode( 'casaroyal_progress_bar', 'casaroyal_progress_bar_func' );

vc_map( array(
  	'name' => esc_html__( 'Progress Bar', 'casaroyal' ),
	'base' => 'casaroyal_progress_bar',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal google map', 'casaroyal' ),
	'params' => array(
        array(
            "type" => "textfield",
            "class" => "",
            "heading" => esc_html__("Label", "casaroyal"),
            "param_name" => "title",
            "admin_label" => true,
            "value" => "",
            'edit_field_class' => 'vc_col-sm-6',
        ),
        array(
            "type" => "textfield",
            "class" => "",
            "heading" => esc_html__("Percentage", "casaroyal"),
            "param_name" => "percentage",
            'description' => esc_html__( 'Add here progress percentage from 0 to 100 (only number).', 'casaroyal' ),
            "admin_label" => true,
            "value" => "",
            'edit_field_class' => 'vc_col-sm-6',
        ),
        array(
            'type' => 'colorpicker',
            'heading' => esc_html__( 'Stroke Color', 'casaroyal' ),
            'param_name' => 'stroke_color',
            'description' => esc_html__( 'Select custom stroke color for your circle.', 'casaroyal' ),
            'std' => '#f55a4e',
            'edit_field_class' => 'vc_col-sm-6',
        ),
         array(
            'type' => 'checkbox',
            'heading' => esc_html__( 'Animated Background', 'casaroyal' ),
            'param_name' => 'animated_bg',
            'edit_field_class' => 'vc_col-sm-6',
        ),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

?>