<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_progress_circle_func( $atts ) {

	extract( shortcode_atts( array(
        "title" => "Label",
        "stroke_color" => "#f55a4e",
        "stroke_width" => "2",
        "percentage" => "33",
    	"css" => "",
   	), $atts ) );

	ob_start();

	$class_to_filter = '';
	$class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

    $circle_percentage = ($percentage * 629)/100;

	?>
    
    <div class="casaroyal-progress-circle">
        
        <span class="casaroyal-progress-circle-precentage"><span class="count"><?php echo esc_attr($percentage); ?></span>%</span>

        <span class="progress-block" data-name="<?php echo esc_attr($title); ?>" data-percent="<?php echo esc_attr($percentage); ?>%">
            <svg class="progress-block-circle" viewBox="-10 -10 220 220">
                <g fill="none" stroke-width="<?php echo esc_attr($stroke_width); ?>" transform="translate(100,100)">
                    <path d="M 0,-100 A 100,100 0 0,1 86.6,-50" stroke="<?php echo esc_attr($stroke_color); ?>"/>
                    <path d="M 86.6,-50 A 100,100 0 0,1 86.6,50" stroke="<?php echo esc_attr($stroke_color); ?>"/>
                    <path d="M 86.6,50 A 100,100 0 0,1 0,100" stroke="<?php echo esc_attr($stroke_color); ?>"/>
                    <path d="M 0,100 A 100,100 0 0,1 -86.6,50" stroke="<?php echo esc_attr($stroke_color); ?>"/>
                    <path d="M -86.6,50 A 100,100 0 0,1 -86.6,-50" stroke="<?php echo esc_attr($stroke_color); ?>"/>
                    <path d="M -86.6,-50 A 100,100 0 0,1 0,-100" stroke="<?php echo esc_attr($stroke_color); ?>"/>
                </g>
            </svg>
            <svg viewBox="-10 -10 220 220">
                <path d="M200,100 C200,44.771525 155.228475,0 100,0 C44.771525,0 0,44.771525 0,100 C0,155.228475 44.771525,200 100,200 C155.228475,200 200,155.228475 200,100 Z" stroke-dashoffset="<?php echo esc_attr($circle_percentage); ?>"></path>
            </svg>
        </span>

    </div>

    <?php

    return ob_get_clean();

}
add_shortcode( 'casaroyal_progress_circle', 'casaroyal_progress_circle_func' );

vc_map( array(
  	'name' => esc_html__( 'Progress Circle', 'casaroyal' ),
	'base' => 'casaroyal_progress_circle',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal google map', 'casaroyal' ),
	'params' => array(
        array(
            "type" => "textfield",
            "class" => "",
            "heading" => esc_html__("Label", "casaroyal"),
            "param_name" => "title",
            "admin_label" => true,
            "value" => "",
            'edit_field_class' => 'vc_col-sm-6',
        ),
        array(
            "type" => "textfield",
            "class" => "",
            "heading" => esc_html__("Stroke Width", "casaroyal"),
            "param_name" => "stroke_width",
            'description' => esc_html__( 'Add here stroke width in px (only number).', 'casaroyal' ),
            "admin_label" => true,
            "value" => "",
            'edit_field_class' => 'vc_col-sm-6',
        ),
        array(
            'type' => 'colorpicker',
            'heading' => esc_html__( 'Stroke Color', 'casaroyal' ),
            'param_name' => 'stroke_color',
            'description' => esc_html__( 'Select custom stroke color for your circle.', 'casaroyal' ),
            'std' => '#f55a4e',
            'edit_field_class' => 'vc_col-sm-6',
        ),
        array(
            "type" => "textfield",
            "class" => "",
            "heading" => esc_html__("Percentage", "casaroyal"),
            "param_name" => "percentage",
            'description' => esc_html__( 'Add here progress percentage from 0 to 100 (only number).', 'casaroyal' ),
            "admin_label" => true,
            "value" => "",
            'edit_field_class' => 'vc_col-sm-6',
        ),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

?>