<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_promo_func( $atts, $content ) {

	extract( shortcode_atts( array(
		'title' => 'Let Us Guid You Home',
		'title_color' => '#111111',
		'content_text' => '',
		'content_color' => '#6d6d6d',
		'content_bg_color' => '#ffffff',
		'content_align' => 'left',
		'bg_color' => '#111111',
		'add_button' => '',
		'button_text' => '',
		'button_url' => '#',
		'add_icon' => '',
    	'icon_type' => 'fontawesome',
    	'icon_fontawesome' => '',
		'icon_openiconic' => '',
		'icon_typicons' => '',
		'icon_entypo' => '',
		'icon_linecons' => '',
		'icon_monosocial' => '',
		'image' => '',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$img_id = preg_replace( '/[^\d]/', '', $image );
	$link_image = wp_get_attachment_image_src( $img_id, 'full' );
	$td_title_bg_img = $link_image[0];

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	$icon_class = '';
	if ( 'true' === $add_icon ) {
		vc_icon_element_fonts_enqueue( $icon_type );

		if ( isset( ${'icon_' . $icon_type} ) ) {
			$icon_class = ${'icon_' . $icon_type};
		} else {
			$icon_class = 'fa fa-adjust';
		}
	}

	$MODS = get_theme_mods();
    foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

    // Scroll Animation
    $scroll_animation;
    if(strlen($MODS['scroll_animation'])>0) {
        $scroll_animation = $MODS['scroll_animation'];
    }
    //

	?>

	<div class="casaroyal-property-asf-wrapper" <?php if(!empty($bg_color) AND empty($td_title_bg_img)) { ?>style="background-color: <?php echo esc_attr($bg_color); ?>"<?php } ?>>

		<?php if(!empty($td_title_bg_img)) { ?><div class="casaroyal-page-title-image-background" <?php if(!empty($td_title_bg_img)) { ?>style="background-image: url(<?php echo esc_url($td_title_bg_img); ?>);"<?php } ?>></div><?php } ?>

		<div class="container">

			<div class="casaroyal-property-asf <?php echo esc_attr($css_class); ?>">

				<div class="row">

					<div class="col-md-7" style="float: <?php echo esc_attr($content_align);?>; ">

						<div class="casaroyal-promo-block <?php if($scroll_animation == "on") { ?>aos-init<?php } ?> aos-animate" <?php if($scroll_animation == "on") { ?>data-aos="fade-up"<?php } ?> style="background-color: <?php echo esc_attr($content_bg_color); ?>;">

							<?php if(!empty($title)) { ?><h2 style="color: <?php echo esc_attr($title_color); ?>;"><?php echo wp_kses($title, true); ?></h2><?php } ?>

							<?php if(!empty($content_text)) { ?><p style="color: <?php echo esc_attr($content_color); ?>;"><?php echo wp_kses($content_text, true); ?></p><?php } ?>

							<?php if ( 'true' === $add_button AND !empty($button_text) ) { ?>
							<div class="casaroyal-button-container casaroyal-button-align-left casaroyal-button-icon-align-right casaroyal-button-style-default casaroyal-button-size-medium">
								<a href="<?php echo esc_url($button_url); ?>" class="btn-casaroyal">
									<?php echo esc_attr($button_text); ?>
									<?php if(!empty($icon_class)) { echo "<i class='" . wp_kses($icon_class, true) . "'></i>"; } ?>
								</a>
							</div>
							<?php } ?>

						</div>

					</div>

			    </div>
					
			</div>

		</div>

	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_promo', 'casaroyal_promo_func' );

vc_map( array(
  	'name' => esc_html__( 'Promo Block', 'casaroyal' ),
	'base' => 'casaroyal_promo',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal banner', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Title', 'casaroyal' ),
			'param_name' => 'title',
			'value' => 'Let Us Guid You Home',
			'admin_label' => true,
			'description' => esc_html__( 'Enter title here.', 'casaroyal' ),
			"group" => "Settings",
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Title Color', 'casaroyal' ),
			'param_name' => 'title_color',
			'description' => esc_html__( 'Select color for title.', 'casaroyal' ),
			"group" => "Settings",
			'std' => '#111111',
		),
		array(
			'type' => 'textarea',
			'heading' => esc_html__( 'Content', 'casaroyal' ),
			'param_name' => 'content_text',
			'value' => '',
			'description' => esc_html__( 'Enter content here.', 'casaroyal' ),
			"group" => "Settings",
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Content Color', 'casaroyal' ),
			'param_name' => 'content_color',
			'description' => esc_html__( 'Select color for content text.', 'casaroyal' ),
			"group" => "Settings",
			'std' => '#6d6d6d',
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Content Background Color', 'casaroyal' ),
			'param_name' => 'content_bg_color',
			'description' => esc_html__( 'Select color for content background.', 'casaroyal' ),
			"group" => "Settings",
			'std' => '#ffffff',
		),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Content Alignment', 'casaroyal' ),
			'param_name' => 'content_align',
			'value' => array(
				__( 'Left', 'casaroyal' ) => 'left',
				__( 'Right', 'casaroyal' ) => 'right',
			),
			'std' => 'left',
			'group' => esc_html__( 'Settings', 'casaroyal' ),
		),
		array(
			'type' => 'checkbox',
			'heading' => esc_html__( 'Add button?', 'casaroyal' ),
			'param_name' => 'add_button',
			'group' => esc_html__( 'Button', 'casaroyal' ),
			'std' => 'false',
		),
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Button text', 'casaroyal' ),
			'param_name' => 'button_text',
			'value' => '',
			'dependency' => array(
				'element' => 'add_button',
				'value' => 'true',
			),
			'description' => esc_html__( 'Enter button text here.', 'casaroyal' ),
			"group" => "Button",
		),
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Button Url', 'casaroyal' ),
			'param_name' => 'button_url',
			'value' => '#',
			'dependency' => array(
				'element' => 'add_button',
				'value' => 'true',
			),
			'description' => esc_html__( 'Enter button url here.', 'casaroyal' ),
			"group" => "Button",
		),
		array(
			'type' => 'checkbox',
			'heading' => esc_html__( 'Add icon?', 'casaroyal' ),
			'param_name' => 'add_icon',
			'dependency' => array(
				'element' => 'add_button',
				'value' => 'true',
			),
			'group' => esc_html__( 'Button', 'casaroyal' ),
			'std' => 'false',
		),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Icon library', 'casaroyal' ),
			'value' => array(
				__( 'Font Awesome', 'casaroyal' ) => 'fontawesome',
				__( 'Open Iconic', 'casaroyal' ) => 'openiconic',
				__( 'Typicons', 'casaroyal' ) => 'typicons',
				__( 'Entypo', 'casaroyal' ) => 'entypo',
				__( 'Linecons', 'casaroyal' ) => 'linecons',
				__( 'Mono Social', 'casaroyal' ) => 'monosocial',
			),
			'param_name' => 'icon_type',
			'description' => esc_html__( 'Select icon library.', 'casaroyal' ),
			'dependency' => array(
				'element' => 'add_icon',
				'value' => 'true',
			),
			'std' => 'fontawesome',
			'group' => esc_html__( 'Button', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_fontawesome',
			'value' => 'fa fa-info-circle',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'fontawesome',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
			'std' => 'fa fa-info-circle',
			'group' => esc_html__( 'Button', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_openiconic',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'type' => 'openiconic',
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'openiconic',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
			'group' => esc_html__( 'Button', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_typicons',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'type' => 'typicons',
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'typicons',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
			'group' => esc_html__( 'Button', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_entypo',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'type' => 'entypo',
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'entypo',
			),
			'group' => esc_html__( 'Button', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_linecons',
			'settings' => array(
				'emptyIcon' => false,
				// default true, display an "EMPTY" icon?
				'type' => 'linecons',
				'iconsPerPage' => 4000,
				// default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'linecons',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
			'group' => esc_html__( 'Button', 'casaroyal' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'casaroyal' ),
			'param_name' => 'icon_monosocial',
			'value' => 'vc-mono vc-mono-fivehundredpx', // default value to backend editor admin_label
			'settings' => array(
				'emptyIcon' => false, // default true, display an "EMPTY" icon?
				'type' => 'monosocial',
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'monosocial',
			),
			'description' => esc_html__( 'Select icon from library.', 'casaroyal' ),
			'group' => esc_html__( 'Button', 'casaroyal' ),
		),
        array(
			'type' => 'attach_image',
			'heading' => esc_html__( 'Background Image', 'casaroyal' ),
			'param_name' => 'image',
			'value' => '',
			'description' => esc_html__( 'Select image from media library.', 'casaroyal' ),
			"group" => "Settings",
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Background Solid Color', 'casaroyal' ),
			'param_name' => 'bg_color',
			'description' => esc_html__( 'Select color for background.', 'casaroyal' ),
			"group" => "Settings",
			'std' => '#111111',
		),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

