<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_properties_asf_func( $atts, $content ) {

	extract( shortcode_atts( array(
		'title' => 'Let Us Guid You Home',
		'title_color' => '#232628',
		'subtitle' => 'Find the house of your dreams',
		'subtitle_color' => '#9b9b9b',
		'asf_type' => 'extended',
		'image' => '',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$img_id = preg_replace( '/[^\d]/', '', $image );
	$link_image = wp_get_attachment_image_src( $img_id, 'large' );
	$td_title_bg_img = $link_image[0];

	//wp_enqueue_style( 'jquery-ui' );
	wp_enqueue_script( 'jquery-ui-slider' );
    wp_enqueue_script( 'jquery-ui-draggable' );
    wp_enqueue_script( 'touch-punch' );

	$prices = casaroyal_get_max_min_price();

	global $post;

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	$MODS = get_theme_mods();
    foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

    // Scroll Animation
    $scroll_animation;
    if(strlen($MODS['scroll_animation'])>0) {
        $scroll_animation = $MODS['scroll_animation'];
    }
    //

	?>

	<div class="casaroyal-property-asf-wrapper">

		<?php if(!empty($td_title_bg_img)) { ?><div class="casaroyal-page-title-image-background" <?php if( !empty($td_title_bg_img) AND $scroll_animation == "on" ) { ?>data-parallax="scroll" data-image-src="<?php echo esc_url($td_title_bg_img); ?>"<?php } ?> <?php if(!empty($td_title_bg_img)){ ?>style="background-image: url(<?php echo esc_url($td_title_bg_img); ?>);"<?php } ?>></div><?php } ?>

		<div class="container">

			<div class="casaroyal-property-asf <?php echo esc_attr($css_class); ?>">

				<?php 

			        if( !empty($title) AND $asf_type == "minimalist" ) {

			    ?>

			    <h2 class="title search-heading <?php if($scroll_animation == "on") { ?>aos-init<?php } ?>" <?php if($scroll_animation == "on") { ?>data-aos="fade-up"<?php } ?> style="color:<?php echo esc_attr($title_color); ?>;"><?php echo esc_attr($title); ?></h2>
			    <?php if(!empty($subtitle)) { ?><p class="search-heading-subtitle <?php if($scroll_animation == "on") { ?>aos-init<?php } ?>" <?php if($scroll_animation == "on") { ?>data-aos="fade-up"<?php } ?> style="color:<?php echo esc_attr($subtitle_color); ?>;"><?php echo esc_attr($subtitle); ?></p><?php } ?>

			    <?php }

					// Get all the Customized Theme Mods
			        $MODS = get_theme_mods();
			        foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

			        // Properties Search
			        global $properties_search_url;
			        if(strlen($MODS['properties_search_url'])>0) {
			            $properties_search_url = $MODS['properties_search_url'];
			        }

			        // Currency Symbol
			        global $search_filter_currency_symbol;
			        if(strlen($MODS['search_filter_currency_symbol'])>0) {
			            $search_filter_currency_symbol = $MODS['search_filter_currency_symbol'];
			        }

			        if( !empty($properties_search_url) ):

			        	?>

			            <div class="advance-search as-form-wrap <?php if($scroll_animation == "on") { ?>aos-init<?php } ?>" <?php if($scroll_animation == "on") { ?>data-aos="fade-up"<?php } ?>>

						    <?php 

						        if( !empty($title) AND $asf_type == "extended" ) {

						    ?>

						    <div class="casaroyal-property-asf-title">
						        <h4 class="title search-heading"><i class="fa fa-home" aria-hidden="true"></i><?php echo esc_attr($title); ?></h4>
						    </div>

						    <?php } ?>

						    <?php if( $asf_type == "extended" ) { ?>
						    
						    <form class="row advance-search-form clearfix" action="<?php echo get_permalink( $properties_search_url ); ?>" method="get">
						        
						        <div class="af-estate-search-field col-md-4">

						        	<div class="cardojo-price-range-holder">

							            <label><?php esc_html_e('Price', 'casaroyal'); ?></label> <span class="min-price-text"><?php if(!empty($search_filter_currency_symbol)) { echo esc_attr($search_filter_currency_symbol); } ?><span><?php if(!empty($prices)) { echo esc_attr(min($prices)); } ?></span></span> - <span class="max-price-text"><?php if(!empty($search_filter_currency_symbol)) { echo esc_attr($search_filter_currency_symbol); } ?><span><?php if(!empty($prices)) { echo esc_attr(max($prices)); } ?></span></span>

							        </div>

							        <input type="hidden" name="min-price" id="min-price" value=""/>
							        <input type="hidden" name="max-price" id="max-price" value=""/>

						            <input type="hidden" id="priceMin" value="<?php if(!empty($prices)) { echo esc_attr(min($prices)); } ?>">
				                    <input type="hidden" id="priceMax" value="<?php if(!empty($prices)) { echo esc_attr(max($prices)); } ?>">

					             	<div id="priceRange"></div>

						        </div>

						        <div class="af-estate-search-field col-md-4">
						            <label for="select-property-type"><?php esc_html_e('Type', 'casaroyal'); ?></label>
						            <span class="selectwrap">
						                <select name="type" id="select-property-type" class="search-select">
						                    <?php advance_hierarchical_options('property-type', __('Select Type', 'casaroyal')); ?>
						                </select>
						            </span>
						        </div>

						        <div class="af-estate-search-field col-md-4">
						            <label for="location"><?php esc_html_e('Location', 'casaroyal'); ?></label>
						            <span class="selectwrap">
						                <select name="location" id="location" class="search-select">
						                    <?php advance_hierarchical_options('property-city', __('Select Location', 'casaroyal')); ?>
						                </select>
						            </span>
						        </div>

						        <div class="af-estate-search-field col-md-4">
						            <label for="select-status"><?php esc_html_e('Status', 'casaroyal'); ?></label>
						            <span class="selectwrap">
						                <select name="status" id="select-status" class="search-select">
						                    <?php advance_search_options('property-status', __('Select Status', 'casaroyal')); ?>
						                </select>
						            </span>
						        </div>

						        <div class="af-estate-search-field col-md-2">
						            <label for="select-bedrooms"><?php esc_html_e('Min Beds', 'casaroyal'); ?></label>
						            <span class="selectwrap">
						                <select name="bedrooms" id="select-bedrooms" class="search-select">
						                    <?php numbers_list('bedrooms', ''); ?>
						                </select>
						            </span>
						        </div>

						        <div class="af-estate-search-field col-md-2">
						            <label for="select-bathrooms"><?php esc_html_e('Min Baths', 'casaroyal'); ?></label>
						            <span class="selectwrap">
						                <select name="bathrooms" id="select-bathrooms" class="search-select">
						                    <?php numbers_list('bathrooms', ''); ?>
						                </select>
						            </span>
						        </div>

						        <div class="af-estate-search-field col-md-4">
						            <input type="submit" value="<?php esc_html_e('Find Properties', 'casaroyal'); ?>" class="af-estate-search-btn">
						        </div>

						    </form>

					        <?php } else { ?>

					        <form class="row advance-search-form clearfix minimal-search-form minimal-search-form-casaroyal-style" action="<?php global $properties_search_url; echo get_permalink( $properties_search_url ); ?>" method="get">

					        	<div class="col-md-5">

						    		<div class="row">

								        <div class="af-estate-search-field col-md-7">
								            <span class="selectwrap" data-label="<?php esc_html_e('Type', 'casaroyal'); ?>">
								                <select name="type" id="select-property-type" class="search-select">
								                    <?php advance_hierarchical_options('property-type', __('Select Type', 'casaroyal')) ?>
								                </select>
								            </span>
								        </div>

								        <div class="af-estate-search-field col-md-5">
								            <span class="selectwrap" data-label="<?php esc_html_e('Status', 'casaroyal'); ?>">
								                <select name="status" id="select-status" class="search-select">
								                    <?php advance_search_options('property-status', __('Select Status', 'casaroyal')); ?>
								                </select>
								            </span>
								        </div>

								        <div class="af-estate-search-field col-md-6" style="display: none;">
								            <span class="selectwrap" data-label="<?php esc_html_e('Location', 'casaroyal'); ?>">
								                <select name="location" id="location" class="search-select">
								                    <?php advance_hierarchical_options('property-city', __('Select Location', 'casaroyal')); ?>
								                </select>
								            </span>
								        </div>

							       	</div>

						      	</div>

						      	<div class="col-md-7">

						    		<div class="row">

								        <div class="af-estate-search-field col-lg-8 col-md-7">
								            <input type="text" name="keyword" class="casaroyal-search-keyword" placeholder="<?php esc_html_e('Search for properties, suburbs, or keywords…', 'casaroyal'); ?>" autocomplete="off">
								            <ul class="casaroyal-search-locations-list">
								            	<li><a href="<?php echo get_permalink( $properties_search_url ); ?>"><i class="fa fa-align-justify" aria-hidden="true"></i><?php esc_html_e('All Properties', 'casaroyal'); ?></a></li>
								            	<?php 

								            		$taxonomy_terms = get_terms( 'property-city', array( 'hide_empty' => false, 'parent' => 0 ) ); 

								            		if ( ! empty( $taxonomy_terms ) ) {
														foreach ( $taxonomy_terms as $term ) {

															$link = get_term_link( $term );

															echo '<li><a data-location="' . $term->slug . '" href="' . $link . '"><i class="fa fa-dot-circle-o" aria-hidden="true"></i>in ' . $term->name . ' <span class="listings_count">' . $term->count . '</span></a></li>';

															$child_terms = get_terms( 'property-city', array( 'hide_empty' => false, 'parent' => $term->term_id ) );

															if ( ! empty( $child_terms ) ) {
																// recursive call
																foreach ( $child_terms as $term ) {
																	$link = get_term_link( $term );
																	echo '<li><a data-location="' . $term->slug . '" class="property-location-child" href="' . $link . '"><i class="fa fa-dot-circle-o" aria-hidden="true"></i>in ' . $term->name . ' <span class="listings_count">' . $term->count . '</span></a></li>';
																}
															}
														}
													}

							            		?>
								            </ul>
								        </div>

								        <input type="hidden" name="location" id="custom-location" value=""/>

								        <div class="af-estate-search-field col-lg-4 col-md-5">
								            <input style="margin-top: 0 !important; margin-bottom: 18px !important;" type="submit" value="<?php esc_html_e('Find Properties', 'casaroyal'); ?>" class="af-estate-search-btn">
								        </div>

								    </div>

						    	</div>

					       	</form>

					        <?php } ?>

						</div>

			            <?php

			        endif;

				?>
					
			</div>

		</div>

	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_properties_asf', 'casaroyal_properties_asf_func' );

vc_map( array(
  	'name' => esc_html__( 'Real Estate Search Form', 'casaroyal' ),
	'base' => 'casaroyal_properties_asf',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal banner', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Title', 'casaroyal' ),
			'param_name' => 'title',
			'value' => 'Let Us Guid You Home',
			'admin_label' => true,
			'description' => esc_html__( 'Enter title here.', 'casaroyal' ),
			"group" => "Settings",
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Title Color', 'casaroyal' ),
			'param_name' => 'title_color',
			'description' => esc_html__( 'Select color for title.', 'casaroyal' ),
			"group" => "Settings",
			'std' => '#232628',
		),
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Sub title', 'casaroyal' ),
			'param_name' => 'subtitle',
			'value' => 'Find the house of your dreams',
			'admin_label' => true,
			'description' => esc_html__( 'Enter sub title here.', 'casaroyal' ),
			"group" => "Settings",
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Sub title Color', 'casaroyal' ),
			'param_name' => 'subtitle_color',
			'description' => esc_html__( 'Select color for sub title.', 'casaroyal' ),
			"group" => "Settings",
			'std' => '#9b9b9b',
		),
		array(
            "type" => "dropdown",
            "class" => "",
            "heading" => esc_html__("Search Box Type", "casaroyal"),
            "param_name" => "asf_type",
            'admin_label' => true,
            "value" => array( esc_html__("Extended", "casaroyal") => "extended", esc_html__("Minimalist", "casaroyal") => "minimalist" ),
            "std" => "extended",
            "group" => "Settings",
        ),
        array(
			'type' => 'attach_image',
			'heading' => esc_html__( 'Background Image', 'casaroyal' ),
			'param_name' => 'image',
			'value' => '',
			'description' => esc_html__( 'Select image from media library.', 'casaroyal' ),
			"group" => "Settings",
		),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

