<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_properties_carousel_func( $atts, $content ) {

	extract( shortcode_atts( array(
		'type' => '',
		'number' => '4',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	$MODS = get_theme_mods();
    foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

    // Scroll Animation
    $scroll_animation;
    if(strlen($MODS['scroll_animation'])>0) {
        $scroll_animation = $MODS['scroll_animation'];
    }
    //

	?>

	<div class="casaroyal-inline-block <?php echo esc_attr($css_class); ?> <?php if($scroll_animation == "on") { ?>aos-init<?php } ?>" <?php if($scroll_animation == "on") { ?>data-aos="fade-left" data-aos-delay="300"<?php } ?>>

		<div class='owl-demo owl-carousel owl-theme owl-properties property-grid-view'>

			<?php

				if($type == "featured") {
					$slider_args = array(
					    'post_type' => 'property',
					    'posts_per_page' => $number,
					    'meta_query' => array(
					        array(
					            'key' => 'ft_featured',
					            'value' => 1,
		                        'compare' => '=',
		                        'type'  => 'NUMERIC'
					        )
					    )
					);
				} else {
					$slider_args = array(
					    'post_type' => 'property',
					    'posts_per_page' => $number
					);
				}

				$slider_query = new WP_Query( $slider_args );

				if($slider_query->have_posts()){
	        
		        	while ( $slider_query->have_posts() ) :

			            $slider_query->the_post();

			            ?> <div class='item'><?php
	                
	                    // Display Property in grid layout
	                    get_template_part('template-parts/real-estate/property-item-grid-carousel');

	                    ?> </div><?php

	                endwhile;
	                wp_reset_postdata();

				} else {

				    // no properties added to homepage slider

				}

			?>

        </div>

	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_properties_carousel', 'casaroyal_properties_carousel_func' );

vc_map( array(
  	'name' => esc_html__( 'Real Estate Carousel', 'casaroyal' ),
	'base' => 'casaroyal_properties_carousel',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom real estate properties carousel', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Number of Properties', 'casaroyal' ),
			'param_name' => 'number',
			'value' => '3',
			'admin_label' => true,
			'description' => esc_html__( 'Enter the properties amount to be displayed.', 'casaroyal' ),
			"group" => "Settings",
		),
		array(
            "type" => "dropdown",
            "class" => "",
            "heading" => esc_html__("Properties Type", "casaroyal"),
            "param_name" => "type",
            'admin_label' => true,
            "value" => array( esc_html__("Featured", "casaroyal") => "featured", esc_html__("Recent properties", "casaroyal") => "recent" ),
            "std" => "recent",
            "group" => "Settings",
        ),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

