<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_properties_grid_func( $atts, $content ) {

	extract( shortcode_atts( array(
		'type' => '',
		'number' => '4',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	?>

	<div class="casaroyal-inline-block <?php echo esc_attr($css_class); ?>">

		<div class="properties-list-wrapper row property-grid-view clearfix masonry-container">

			<?php

				if($type == "featured") {
					$slider_args = array(
					    'post_type' => 'property',
					    'posts_per_page' => $number,
					    'meta_query' => array(
					        array(
					            'key' => 'ft_featured',
					            'value' => 1,
		                        'compare' => '=',
		                        'type'  => 'NUMERIC'
					        )
					    )
					);
				} else {
					$slider_args = array(
					    'post_type' => 'property',
					    'posts_per_page' => $number,
					);
				}

				$current = -1;

				$slider_query = new WP_Query( $slider_args );

				if($slider_query->have_posts()){
	        
		        	while ( $slider_query->have_posts() ) :

		        		$current++;

			            $slider_query->the_post();

			            // Display Property in grid layout
	                    casaroyal_get_template_part('template-parts/real-estate/property-item-grid', [ 'current' => $current ]);

	                endwhile;
	                wp_reset_postdata();

				} else {

				    // no properties added to homepage slider

				}

			?>

		</div>

	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_properties_grid', 'casaroyal_properties_grid_func' );

vc_map( array(
  	'name' => esc_html__( 'Real Estate Grid', 'casaroyal' ),
	'base' => 'casaroyal_properties_grid',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom real estate properties grid view', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Number of Properties', 'casaroyal' ),
			'param_name' => 'number',
			'value' => '4',
			'admin_label' => true,
			'description' => esc_html__( 'Enter the properties amount to be displayed.', 'casaroyal' ),
			"group" => "Settings",
		),
		array(
            "type" => "dropdown",
            "class" => "",
            "heading" => esc_html__("Properties Type", "casaroyal"),
            "param_name" => "type",
            'admin_label' => true,
            "value" => array( esc_html__("Featured", "casaroyal") => "featured", esc_html__("Recent properties", "casaroyal") => "recent" ),
            "std" => "recent",
            "group" => "Settings",
        ),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

