<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_properties_map_func( $atts, $content ) {

	extract( shortcode_atts( array(
		'height' => '500',
    	'css' => '',
   	), $atts ) );

	ob_start();

	//wp_enqueue_style( 'jquery-ui' );
	wp_enqueue_script( 'jquery-ui-slider' );
    wp_enqueue_script( 'jquery-ui-draggable' );
    wp_enqueue_script( 'touch-punch' );

	$prices = casaroyal_get_max_min_price();

	global $post;

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	?>

	<div class="casaroyal-property-map <?php echo esc_attr($css_class); ?>">

		<div id="listings-map" <?php if(!empty($height)) { ?>style="height:<?php echo esc_attr($height); ?>px;"<?php } ?>></div>

		<div class="casaroyal-property-asf-map casaroyal-property-asf">

			<div class="container">

				<?php

					// Get all the Customized Theme Mods
			        $MODS = get_theme_mods();
			        foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

			        // Establish the Phone Number
			        global $properties_search_url;
			        if(strlen($MODS['properties_search_url'])>0) {
			            $properties_search_url = $MODS['properties_search_url'];
			        }

			        // Currency Symbol
			        global $search_filter_currency_symbol;
			        if(strlen($MODS['search_filter_currency_symbol'])>0) {
			            $search_filter_currency_symbol = $MODS['search_filter_currency_symbol'];
			        }

			        if( !empty($properties_search_url) ):

			            ?>

		            <div class="advance-search as-form-wrap">

					    <?php 

					        if(!empty($title)) {

					    ?>

					    <div class="casaroyal-property-asf-title">
					        <h4 class="title search-heading"><i class="fa fa-home" aria-hidden="true"></i><?php echo esc_attr($title); ?></h4>
					    </div>

					    <?php } ?>
					    
					    <form class="row advance-search-form clearfix" action="<?php global $properties_search_url; echo get_permalink( $properties_search_url ); ?>" method="get">

					        <div class="af-estate-search-field col-md-4">

					        	<div class="cardojo-price-range-holder">

						            <label><?php esc_html_e('Price', 'casaroyal'); ?></label> <span class="min-price-text"><?php if(!empty($search_filter_currency_symbol)) { echo esc_attr($search_filter_currency_symbol); } ?><span><?php if(!empty($prices)) { echo esc_attr(min($prices)); } ?></span></span> - <span class="max-price-text"><?php if(!empty($search_filter_currency_symbol)) { echo esc_attr($search_filter_currency_symbol); } ?><span><?php if(!empty($prices)) { echo esc_attr(max($prices)); } ?></span></span>

						        </div>

						        <input type="hidden" name="min-price" id="min-price" value=""/>
						        <input type="hidden" name="max-price" id="max-price" value=""/>

					            <input type="hidden" id="priceMin" value="<?php if(!empty($prices)) { echo esc_attr(min($prices)); } ?>">
			                    <input type="hidden" id="priceMax" value="<?php if(!empty($prices)) { echo esc_attr(max($prices)); } ?>">

				             	<div id="priceRange"></div>

					        </div>

					        <div class="af-estate-search-field col-md-4">
					            <label for="select-property-type"><?php esc_html_e('Type', 'casaroyal'); ?></label>
					            <span class="selectwrap">
					                <select name="type" id="select-property-type" class="search-select">
					                    <?php advance_hierarchical_options('property-type', __('Select Type', 'casaroyal')); ?>
					                </select>
					            </span>
					        </div>

					        <div class="af-estate-search-field col-md-4">
					            <label for="location"><?php esc_html_e('Location', 'casaroyal'); ?></label>
					            <span class="selectwrap">
					                <select name="location" id="location" class="search-select">
					                    <?php advance_hierarchical_options('property-city', __('Select Location', 'casaroyal')); ?>
					                </select>
					            </span>
					        </div>

					        <div class="af-estate-search-field col-md-4">
					            <label for="select-status"><?php esc_html_e('Status', 'casaroyal'); ?></label>
					            <span class="selectwrap">
					                <select name="status" id="select-status" class="search-select">
					                    <?php advance_search_options('property-status', __('Select Status', 'casaroyal')); ?>
					                </select>
					            </span>
					        </div>

					        <div class="af-estate-search-field col-md-2">
					            <label for="select-bedrooms"><?php esc_html_e('Min Beds', 'casaroyal'); ?></label>
					            <span class="selectwrap">
					                <select name="bedrooms" id="select-bedrooms" class="search-select">
					                    <?php numbers_list('bedrooms', ''); ?>
					                </select>
					            </span>
					        </div>

					        <div class="af-estate-search-field col-md-2">
					            <label for="select-bathrooms"><?php esc_html_e('Min Baths', 'casaroyal'); ?></label>
					            <span class="selectwrap">
					                <select name="bathrooms" id="select-bathrooms" class="search-select">
					                    <?php numbers_list('bathrooms', ''); ?>
					                </select>
					            </span>
					        </div>

					        <div class="af-estate-search-field col-md-4">
					            <input type="submit" value="<?php esc_html_e('Search', 'casaroyal'); ?>" class="af-estate-search-btn">
					        </div>

					        <input type="hidden" name="action" value="casaroyal_ajax_load">
                            <?php wp_nonce_field( 'casaroyal_ajax_load_html', 'casaroyal_ajax_load_nonce' ); ?>

					    </form>

					</div>

		            <?php
			        
			        endif;

				?>

			</div>
				
		</div>

		<div id="properties-grid-view">

			<?php

				$slider_args = array(
				    'post_type' => 'property',
				    'posts_per_page' => -1,
				);

				$slider_query = new WP_Query( $slider_args );

				if($slider_query->have_posts()){
	        
		        	while ( $slider_query->have_posts() ) :

			            $slider_query->the_post();

					    $property_location = get_post_meta($post->ID,'ft_property_location',true);
					    $property_address = get_post_meta($post->ID,'ft_property_address',true);
					    $lat_lng = explode(',',$property_location);
					    if(!empty($lat_lng[0])) {
					        $property_map_lat = $lat_lng[0];
					        $property_map_lang = $lat_lng[1];
					    } else {
					        $property_map_lat = "";
					        $property_map_lang = "";
					    }

					    if( has_post_thumbnail( $post->ID ) ) {
					        $thumb_id = get_post_thumbnail_id();
					        $thumb_url = wp_get_attachment_image_src($thumb_id,'thumbnail-size', true);
					        $thumb_url_final = $thumb_url[0];
					    } else {
					        $thumb_url_final = "";
					    }

					    $map_pin = "";
					    $type_terms = get_the_terms( $post->ID, "property-type" );
					    if(!empty($type_terms) && is_array($type_terms)){
					        $types_array_this = array();
					        foreach($type_terms as $type_term){
					            $types_array_this[] = $type_term->term_id;
					        }
					        $map_pin = casaroyal_get_term_icon_url( $types_array_this[0] );
					    } 
					    if(empty($map_pin)) {
					        $map_pin = get_template_directory_uri().'/images/map-pin.svg';// default icon
					    }

					    $property_price = get_post_meta( $post->ID, 'ft_property_price', true );
					    $currency = get_post_meta( $post->ID, 'ft_property_currency', true );

					?>

					<div class="property-grid-item property-item-data" data-lat="<?php echo esc_attr($property_map_lat); ?>" data-long="<?php echo esc_attr($property_map_lang); ?>" data-title="<?php the_title(); ?>" data-thumb="<?php echo esc_url($thumb_url_final); ?>" data-pin="<?php echo esc_url($map_pin); ?>" data-price="<?php echo esc_attr($currency); echo esc_attr($property_price); ?>" data-type="<?php echo casaroyal_get_property_types_short( $post->ID ); ?>" data-desc="<?php casaroyal_excerpt( 12 ); ?>" data-link="<?php the_permalink() ?>"></div>

				<?php   

		        endwhile;
	        	wp_reset_postdata();

			}

			?>

		</div>
			
	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_properties_map', 'casaroyal_properties_map_func' );

vc_map( array(
  	'name' => esc_html__( 'Real Estate Map', 'casaroyal' ),
	'base' => 'casaroyal_properties_map',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal banner', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Map height', 'casaroyal' ),
			'param_name' => 'height',
			'value' => '',
			'admin_label' => true,
			'description' => esc_html__( 'Enter the map height in pixels.', 'casaroyal' ),
			"group" => "Settings",
		),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

