<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_property_slider_func( $atts, $content ) {

	extract( shortcode_atts( array(
    	'css' => '',
   	), $atts ) );

	ob_start();

	global $post;

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	$MODS = get_theme_mods();
    foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

    // Scroll Animation
    $scroll_animation;
    if(strlen($MODS['scroll_animation'])>0) {
        $scroll_animation = $MODS['scroll_animation'];
    }
    //

	?>

	<div class="casaroyal-property-slider <?php echo esc_attr($css_class); ?>">

		<?php

			$slider_args = array(
			    'post_type' => 'property',
			    'posts_per_page' => -1,
			    'meta_query' => array(
			        array(
			            'key' => 'ft_add_in_slider',
			            'value' => 'yes',
			            'compare' => 'LIKE'
			        )
			    )
			);

			$slider_query = new WP_Query( $slider_args );

			if($slider_query->have_posts()){
		?>

		<div class="property-flexslider <?php if($scroll_animation == "on") { ?>aos-init<?php } ?>" <?php if($scroll_animation == "on") { ?>data-aos="fade-up"<?php } ?>>

			<ul class="slides">

				<?php
                while ( $slider_query->have_posts() ) :
                    $slider_query->the_post();
                    $slider_image_id = get_post_meta( $post->ID, 'ft_slider_image', true );
                    if($slider_image_id){
                        $slider_image_url = wp_get_attachment_image_src( $slider_image_id, 'casaroyal-property-slider' );
                        ?>

						<li style="background-image: url(<?php echo esc_url($slider_image_url[0]); ?>);">
                            <div class="desc-wrap">
                                <div class="slide-description">
                                	<span class="property-slider-price"><?php property_price(); ?></span>
                                    <h3><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h3>
                                    <span class="property-slider-meta">
                                    	<span class="property-slider-meta-item">
			                                <i class="fa fa-dot-circle-o" aria-hidden="true"></i>
			                                <?php
						                        $status_terms = get_the_terms( $post->ID,"property-city" );
						                        if(!empty( $status_terms )){
						                            $status_count = 0;
						                            foreach( $status_terms as $term ){
						                                if( $status_count > 0 ){
						                                    echo ', ';
						                                }
						                                echo $term->name;
						                                $status_count++;
						                            }
						                        }
						                    ?>
						                </span>
						                <span class="property-slider-meta-item">
			                                <i class="fa fa-home" aria-hidden="true"></i>
			                                <?php
						                        $status_terms = get_the_terms( $post->ID,"property-type" );
						                        if(!empty( $status_terms )){
						                            $status_count = 0;
						                            foreach( $status_terms as $term ){
						                                if( $status_count > 0 ){
						                                    echo ', ';
						                                }
						                                echo $term->name;
						                                $status_count++;
						                            }
						                        }
						                    ?>
						                </span>
						                <span class="property-slider-meta-item">
			                                <i class="fa fa-tag" aria-hidden="true"></i>
			                                <?php
						                        $status_terms = get_the_terms( $post->ID,"property-status" );
						                        if(!empty( $status_terms )){
						                            $status_count = 0;
						                            foreach( $status_terms as $term ){
						                                if( $status_count > 0 ){
						                                    echo ', ';
						                                }
						                                echo $term->name;
						                                $status_count++;
						                            }
						                        }
						                    ?>
						                </span>
				                    </span>
                                    <span class="casaroyal-button-container"><a href="<?php the_permalink(); ?>" class="btn"><?php esc_html_e('View Details','casaroyal'); ?></a></span>
                                </div>
                            </div>
                        </li>

						<?php
                    }
                endwhile;
                wp_reset_postdata();
                ?>

			</ul>

		</div>

		<?php
			} else {

			    // no properties added to homepage slider

			}
		?>
			
	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_property_slider', 'casaroyal_property_slider_func' );

vc_map( array(
  	'name' => esc_html__( 'Real Estate Slider', 'casaroyal' ),
	'base' => 'casaroyal_property_slider',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal banner', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

