<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_properties_types_func( $atts, $content ) {

	extract( shortcode_atts( array(
		'number' => '4',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	$MODS = get_theme_mods();
    foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

    // Scroll Animation
    $scroll_animation;
    if(strlen($MODS['scroll_animation'])>0) {
        $scroll_animation = $MODS['scroll_animation'];
    }
    //

	?>

	<div class="properties-cat-wrapper properties-list-wrapper row property-grid-view clearfix <?php echo esc_attr($css_class); ?>">

        <?php

			$args = array(
			    'hierarchical' => 0,
			    'orderby' => 'count',
			    'order' => 'DESC',
			    'number' => $number,
			);

			$current = 0;
			$terms = get_terms( 'property-type', $args );

			if ( $terms ) {

				foreach ( $terms as $term ) {

					$current++;
					$cat_cover = casaroyal_get_term_image_url( $term->term_id, 'casaroyal-portfolio' );

					?>

						<div class="<?php if($current == 2 OR $current == 3 OR $current == 6 OR $current == 7) { echo "col-md-8"; } else { echo "col-md-4"; } ?> property-city-block <?php if($scroll_animation == "on") { ?>aos-init<?php } ?>" <?php if($scroll_animation == "on") { ?>data-aos="fade-up" data-aos-delay="<?php echo esc_attr($current * 100); ?>"<?php } ?>>

							<div class="property-cat-block casaroyal-banner casaroyal-banner-height-layout-1-1" onclick="window.location.href='<?php echo esc_url( get_term_link( $term ) ); ?>'">
								
								<div class="casaroyal-banner-image" style="background-image: url(<?php echo esc_url($cat_cover); ?>);" ></div>
								
								<div class="property-cat-block-content">
									<span class="property-cat-block-name"><?php echo esc_attr($term->name); ?></span>
									<span class="property-cat-block-number"><i class="fa fa-dot-circle-o" aria-hidden="true"></i> <?php echo esc_attr($term->count); echo " "; if($term->count == 1) { esc_html_e( "Property", 'casaroyal' ); } else { esc_html_e( "Properties", 'casaroyal' ); } ?></span>
								</div>
								
								<span class="property-cat-block-link"><i class="fa fa-share" aria-hidden="true"></i></span>
									
							</div>

						</div>

					<?php

				}

			}

		?>
			
	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_properties_types', 'casaroyal_properties_types_func' );

vc_map( array(
  	'name' => esc_html__( 'Real Estate Types', 'casaroyal' ),
	'base' => 'casaroyal_properties_types',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom properties types blocks', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Number of Categories', 'casaroyal' ),
			'param_name' => 'number',
			'value' => '4',
			'admin_label' => true,
			'description' => esc_html__( 'Enter the properties categories amount to be displayed.', 'casaroyal' ),
			"group" => "Settings",
		),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

