<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_share_buttons_func( $atts, $content ) {

	extract( shortcode_atts( array(
    	'page_name' => '',
    	'image' => '',
    	'design' => '',
    	'background_color' => '#000000',
    	'text_color' => '#ffffff',
    	'align' => '',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$img_id = preg_replace( '/[^\d]/', '', $image );
	$link_image = wp_get_attachment_image_src( $img_id, 'large' );
	$img_src = $link_image[0];

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	?>

	<div class="share-page sharrre <?php if($design == "version_2") { echo "share-buttons-v2"; } if($design == "version_3") { echo "share-buttons-v3"; } echo esc_attr($css_class); ?>" style="<?php if(!empty($align) AND $align == "left") { ?>float:left;<?php } elseif($align == "right") { ?>float:right;<?php } ?>" data-pinterest-image="<?php echo esc_url($img_src); ?>" data-name="<?php echo esc_attr($page_name); ?>" data-url="<?php global $wp; $current_url = home_url(add_query_arg(array(),$wp->request)); echo esc_url($current_url); ?>/" data-background="<?php echo esc_attr($background_color); ?>" data-color="<?php echo esc_attr($text_color); ?>"></div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_share_buttons', 'casaroyal_share_buttons_func' );

vc_map( array(
  	'name' => esc_html__( 'Share Buttons', 'casaroyal' ),
	'base' => 'casaroyal_share_buttons',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal share buttons', 'casaroyal' ),
	'params' => array(
		array(
            "type" => "textfield",
            "class" => "",
            "heading" => esc_html__("Page name", "casaroyal"),
            "param_name" => "page_name",
            "admin_label" => true,
            "value" => "Page name",
        ),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Design', 'casaroyal' ),
			'param_name' => 'design',
			'description' => esc_html__( 'Select buttons design.', 'casaroyal' ),
			'value' => array(
				__( 'Default', 'casaroyal' ) => 'default',
				__( 'Version 2', 'casaroyal' ) => 'version_2',
				__( 'Version 3', 'casaroyal' ) => 'version_3',
			),
			'std' => 'inline',
		),
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Alignment', 'casaroyal' ),
			'param_name' => 'align',
			'description' => esc_html__( 'Select buttons alignment.', 'casaroyal' ),
			'value' => array(
				__( 'Inline', 'casaroyal' ) => 'inline',
				__( 'Left', 'casaroyal' ) => 'left',
				__( 'Right', 'casaroyal' ) => 'right',
			),
			'dependency' => array(
				'element' => 'design',
				'value' => array( 'default' ),
			),
			'std' => 'inline',
		),
		array(
			'type' => 'attach_image',
			'heading' => esc_html__( 'Pinterest Image', 'casaroyal' ),
			'param_name' => 'image',
			'value' => '',
			'description' => esc_html__( 'Select image from media library.', 'casaroyal' ),
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Share Button Background Color', 'casaroyal' ),
			'param_name' => 'background_color',
			'description' => esc_html__( 'Select SHARE button background color.', 'casaroyal' ),
			'edit_field_class' => 'vc_col-sm-6',
			'dependency' => array(
				'element' => 'design',
				'value' => array( 'default' ),
			),
			'std' => '#000000',
		),
		array(
			'type' => 'colorpicker',
			'heading' => esc_html__( 'Share Button Text Color', 'casaroyal' ),
			'param_name' => 'text_color',
			'description' => esc_html__( 'Select SHARE text background color.', 'casaroyal' ),
			'edit_field_class' => 'vc_col-sm-6',
			'dependency' => array(
				'element' => 'design',
				'value' => array( 'default' ),
			),
			'std' => '#ffffff',
		),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

