<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_single_property_func( $atts, $content ) {

	extract( shortcode_atts( array(
		'post_id' => '',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	if(has_post_thumbnail( $post_id )) {

		$image_src = wp_get_attachment_image_src( get_post_thumbnail_id( $post_id ), false, '' ); 
		$td_title_bg_img = esc_url($image_src[0]);

	} 

	$MODS = get_theme_mods();
    foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

    // Scroll Animation
    $scroll_animation;
    if(strlen($MODS['scroll_animation'])>0) {
        $scroll_animation = $MODS['scroll_animation'];
    }
    //

	?>

	<div class="bph casaroyal-single-property-shortcode <?php echo esc_attr($css_class); ?> <?php if($scroll_animation == "on") { ?>aos-init<?php } ?> aos-animate" <?php if($scroll_animation == "on") { ?>data-aos="fade-up"<?php } ?>>
	
		<div class="row row-eq-height">

			<div class="col-md-6 bph-image" <?php if(!empty($td_title_bg_img)) { ?>style="background-image: url(<?php echo esc_url($td_title_bg_img); ?>);"<?php } ?>>

				<?php

					$size = 'casaroyal-property-gallery-big';
					$total_images = 0;
					$properties_images = rwmb_meta( 'ft_property_images', 'type=plupload_image&size='.$size, $post_id );

					if( !empty($properties_images) ){

		                foreach( $properties_images as $prop_image_id=>$prop_image_meta ){

		                	$total_images++;

		                	?>

		                	<a data-fancybox-group="casaroyal-gallery-<?php echo esc_attr($post_id); ?>" class="fancybox" href="<?php echo esc_url($prop_image_meta['full_url']); ?>"></a>

		                	<?php

		                }

		                ?>

		                <a data-open-id="casaroyal-gallery-<?php echo esc_attr($post_id); ?>" class="casaroyal-image-gallery open-album" href="#">
							<?php esc_html_e( 'Photos', 'casaroyal' ); ?> <span>(<?php echo esc_attr($total_images); ?>)</span>
						</a>

		                <?php

		            }

                ?>

			</div>

			<div class="col-md-6 bph-meta">

				<span class="bph-type muted">
					<?php echo casaroyal_get_property_types( $post_id ); ?>
					
					<?php
		                /* Property Status. For example: For Sale, For Rent */
		                $status_terms = get_the_terms( $post_id, "property-status" );
		                if(!empty( $status_terms )){
		                    $status_count = 0;
		                    foreach( $status_terms as $term ){
		                        if( $status_count > 0 ){
		                            echo ', ';
		                        }
		                        echo esc_attr($term->name);
		                        $status_count++;
		                    }
		                }
	                ?>
				</span>

				<div class="bph-info-wrapper">

					<h2 class="bph-title">
						<a href="<?php echo esc_url(get_permalink($post_id));?>"><?php $casaroyal_property_sold = get_post_meta( $post_id, '_sold', true ); if( $casaroyal_property_sold == 1 ) { ?><span class="casaroyal-property-sold-out"><?php echo esc_html__('Sold Out','casaroyal'); ?></span> - <?php } ?><?php echo get_the_title( $post_id ); ?></a>
					</h2>

					<?php

						$ft_property_address_city = esc_attr(get_post_meta($post_id, 'ft_property_address_city',true));
						$ft_property_address_state = esc_attr(get_post_meta($post_id, 'ft_property_address_state',true));
						$ft_property_address_zip = esc_attr(get_post_meta($post_id, 'ft_property_address_zip',true));

						if( !empty($ft_property_address_city) AND !empty($ft_property_address_state)) {

					?>

					<p><i class="fa fa-dot-circle-o" aria-hidden="true"></i> <?php echo esc_attr($ft_property_address_city); ?>, <?php echo esc_attr($ft_property_address_state); ?></p>

					<?php } ?>

					<?php $tour_video_url = get_post_meta($post_id, 'ft_tour_video_url', true ); ?>

					<div class="bph-price <?php if(!empty($tour_video_url)) { echo "property-has-video"; } ?>">

						<div class="property-price-wrapper">

							<?php property_price_by_id( $post_id ); ?>

						</div>

					</div>

					<?php if(!empty($tour_video_url)) { ?>

						<a href="<?php echo esc_url($tour_video_url); ?>" class="bph-play-video fancybox fancybox.iframe">
							<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 500 500" style="enable-background:new 0 0 500 500;" xml:space="preserve">
								<style type="text/css">.st0{fill:#FFFFFF;}</style>
								<path class="st0" d="M80.9,488.3L448.7,276c20-11.5,20-40.4,0-52L80.9,11.7c-20-11.5-45,2.9-45,26v424.7
	C35.9,485.5,60.9,499.9,80.9,488.3z"/>
							</svg>
						</a>

					<?php } ?>

				</div>

				<?php 

					$post_meta_data = get_post_custom($post_id);

					if( !empty($post_meta_data['ft_property_size'][0]) OR !empty($post_meta_data['ft_property_bedrooms'][0]) OR !empty($post_meta_data['ft_property_bathrooms'][0]) OR !empty($post_meta_data['ft_property_garage'][0]) ) {

				?>

				<div class="property-meta">

					<?php

						if( !empty($post_meta_data['ft_property_size'][0]) ) {
			                $prop_size = $post_meta_data['ft_property_size'][0];
			                echo '<div class="property-meta-item">';
			                    include( get_template_directory() . '/images/plan2.svg' );
			                    echo '<span class="property-meta-number">' . $prop_size . '</span>';
			                    if( !empty($post_meta_data['ft_property_size_postfix'][0]) ){
			                        $prop_size_postfix = $post_meta_data['ft_property_size_postfix'][0];
			                        echo '<span class="property-meta-name">'.$prop_size_postfix.'</span>';
			                    }
			                echo '</div>';
			        	}

			        	if( !empty($post_meta_data['ft_property_bedrooms'][0]) ) {
			                $prop_bedrooms = floatval($post_meta_data['ft_property_bedrooms'][0]);
			                $bedrooms_label = ($prop_bedrooms > 1)? esc_html__('Beds','casaroyal' ): esc_html__('Bed','casaroyal');
			                echo '<div class="property-meta-item">';
			                    include( get_template_directory() . '/images/bed.svg' );
			                    echo '<span class="property-meta-number">' . $prop_bedrooms . '</span><span class="property-meta-name">'.$bedrooms_label.'</span>';
			                echo '</div>';
			        	}

			        	if( !empty($post_meta_data['ft_property_bathrooms'][0]) ) {
			                $prop_bathrooms = floatval($post_meta_data['ft_property_bathrooms'][0]);
			                $bathrooms_label = ($prop_bathrooms > 1)?esc_html__('Baths','casaroyal' ): esc_html__('Bath','casaroyal');
			                echo '<div class="property-meta-item">';
			                    include( get_template_directory() . '/images/bathtub.svg' );
			                    echo '<span class="property-meta-number">' . $prop_bathrooms . '</span><span class="property-meta-name">'.$bathrooms_label.'</span>';
			                echo '</div>';
			        	}

			        	if( !empty($post_meta_data['ft_property_garage'][0]) ) {
			                $prop_garage = floatval($post_meta_data['ft_property_garage'][0]);
			                $garage_label = ($prop_garage > 1)?esc_html__('Garages','casaroyal' ): esc_html__('Garage','casaroyal');
			                echo '<div class="property-meta-item">';
			                    include( get_template_directory() . '/images/garage2.svg' );
			                    echo '<span class="property-meta-number">'.$prop_garage .'</span><span class="property-meta-name">'.$garage_label.'</span>';
			                echo '</div>';
			        	}

		        	?>

				</div>

				<?php } ?>

			</div>

		</div>

	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_single_property', 'casaroyal_single_property_func' );

$properties_array = array();

global $properties_post;
$properties_post = new WP_Query();
$properties_post->query('post_type=property&posts_per_page=-1&post_status=publish');

if ( $properties_post->have_posts() ) {

  	while ($properties_post->have_posts()) : $properties_post->the_post();

  		$property_name = get_the_title();
		$properties_array[$property_name] = get_the_ID();

	endwhile;

} wp_reset_postdata();

vc_map( array(
  	'name' => esc_html__( 'Single Property', 'casaroyal' ),
	'base' => 'casaroyal_single_property',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Full width single property', 'casaroyal' ),
	'params' => array(
		array(
            'type' => 'dropdown',
            'heading' => esc_html__( 'Select Property', 'casaroyal' ),
            'param_name' => 'post_id',
            'admin_label' => true,
            'value' => $properties_array,
            'std' => '',
        ),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

