<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_slider_item_func( $atts, $content ) {

    extract( shortcode_atts( array(
        'image' => '',
    ), $atts ) );

    ob_start();

    $img_id = preg_replace( '/[^\d]/', '', $image );
    $link_image = wp_get_attachment_image_src( $img_id, 'full' );
    $img_src = $link_image[0];

    ?>

    <li class="casaroyal-flexslider-bg-image" style="background-image: url(<?php echo esc_url($img_src); ?>);">
        <div class="casaroyal-image-slider-content"><?php echo wp_kses($content, true); ?></div>
    </li>

    <?php

    return ob_get_clean();

}
add_shortcode( 'casaroyal_slider_item', 'casaroyal_slider_item_func' );

vc_map( array(
    'name' => esc_html__( 'Image Slider item', 'casaroyal' ),
    'base' => 'casaroyal_slider_item',
    'icon' => get_template_directory_uri().'/images/vc-icon.png',
    'description' => esc_html__( 'Custom casaroyal image slider content', 'casaroyal' ),
    "content_element" => true,
    "as_child" => array('only' => 'casaroyal_slider'), 
    'params' => array(
        array(
            'type' => 'attach_image',
            'heading' => esc_html__( 'Image', 'casaroyal' ),
            'param_name' => 'image',
            'value' => '',
            'description' => esc_html__( 'Select image from media library.', 'casaroyal' ),
        ),
        array(
            'type' => 'textarea_html',
            'heading' => esc_html__( 'Content', 'casaroyal' ),
            'param_name' => 'content',
            'value' => '',
            'description' => esc_html__( 'You can leave it empty.', 'casaroyal' ),
        ),
    ),
));

if ( class_exists( 'WPBakeryShortCode' ) ) {
    class WPBakeryShortCode_casaroyal_slider_item extends WPBakeryShortCode {
    }
}

