<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_slider_func( $atts, $content = null ) {

    extract( shortcode_atts( array(
        "height_style" => "default",
        "height" => "760",
        "css" => "",
    ), $atts ) );

    ob_start();

    $class_to_filter = '';
    $class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' );
    $css_class = $class_to_filter;

    ?>

    <div class="casaroyal-image-slider flexslider <?php echo esc_attr($css_class); if($height_style == "full_height") { echo "full_height_slider"; } ?>" data-height-style="<?php echo esc_attr($height_style); ?>" data-height="<?php echo esc_attr($height); ?>">

        <ul class="slides">

            <?php echo do_shortcode($content); ?>

        </ul>

    </div>

    <?php

    return ob_get_clean();

}
add_shortcode( 'casaroyal_slider', 'casaroyal_slider_func' );

vc_map( array(
    'name' => esc_html__( 'Image Slider', 'casaroyal' ),
    'base' => 'casaroyal_slider',
    'icon' => get_template_directory_uri().'/images/vc-icon.png',
    'description' => esc_html__( 'Custom casaroyal image slider', 'casaroyal' ),
    "as_parent" => array('only' => 'casaroyal_slider_item'), // Use only|except attributes to limit child shortcodes (separate multiple values with comma)
    "content_element" => true,
    "show_settings_on_create" => false,
    "is_container" => true,
    'params' => array(
        array(
            'type' => 'dropdown',
            'heading' => esc_html__( 'Height', 'casaroyal' ),
            'description' => esc_html__( 'Select background type.', 'casaroyal' ),
            'param_name' => 'height_style',
            'value' => array(
                __( 'Default (760px)', 'casaroyal' ) => 'default',
                __( 'Full Height', 'casaroyal' ) => 'full_height',
                __( 'Custom', 'casaroyal' ) => 'custom',
            ),
            'std' => 'default',
        ),
        array(
            "type" => "textfield",
            "class" => "",
            "heading" => esc_html__("Height in pixels", "casaroyal"),
            "param_name" => "height",
            'description' => esc_html__( 'Add here height in pixels .', 'casaroyal' ),
            "value" => "760",
            'dependency' => array(
                'element' => 'height_style',
                'value' => 'custom',
            ),
        ),
        array(
            'type' => 'css_editor',
            'heading' => esc_html__( 'CSS box', 'casaroyal' ),
            'param_name' => 'css',
            'group' => esc_html__( 'Design Options', 'casaroyal' ),
        ),
    ),
    "js_view" => 'VcColumnView'
));

//Your "container" content element should extend WPBakeryShortCodesContainer class to inherit all required functionality
if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
    class WPBakeryShortCode_casaroyal_slider extends WPBakeryShortCodesContainer {
    }
}

