<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function tabs_func( $atts, $content = null ) {

    extract( shortcode_atts( array(
        "tabs_style" => "horizontal_1",
        "css" => "",
    ), $atts ) );

    global $single_tab_array;
    $single_tab_array = array(); // clear the array
   
    $tabs_nav = '';
    $tabs_content = '';
    $tabs_output = '';

    $class_to_filter = '';
    $class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' );
    $css_class = $class_to_filter;
 
    $tabs_nav .= '<div class="casaroyal-tabs tabs-style-'.$tabs_style.' '.$css_class.'">';
    $tabs_nav .= '<nav>';
    $tabs_nav .= '<ul class="cd-tabs-navigation">';
   
    // execute the '[tab]' shortcode first to get the title and content - acts on global $single_tab_array
    do_shortcode($content);
   
    //declare our vars to be super clean here
    foreach ($single_tab_array as $tab => $tab_attr_array) {

        $icon_class = "";
        $icon_content = "";
        $icon_type = $tab_attr_array['icon_type'];
        $add_icon = $tab_attr_array['add_icon'];
        $icon_fontawesome = $tab_attr_array['icon_fontawesome'];
        $icon_openiconic = $tab_attr_array['icon_openiconic'];
        $icon_typicons = $tab_attr_array['icon_typicons'];
        $icon_entypo = $tab_attr_array['icon_entypo'];
        $icon_linecons = $tab_attr_array['icon_linecons'];
        $icon_monosocial = $tab_attr_array['icon_monosocial'];

        if ( 'true' === $add_icon ) {
            
            vc_icon_element_fonts_enqueue( $icon_type );

            if ( isset( ${'icon_' . $icon_type} ) ) {
                $icon_class = ${'icon_' . $icon_type};
            } else {
                $icon_class = 'fa fa-adjust';
            }
            $icon_content = '<i class="' . wp_kses($icon_class, true) . '"></i>';

        }

        $random_id = rand(1000,2000); // potential duplicate issue.. need to fix
     
        $default = ( $tab == 0 ) ? 'selected' : '';
      
        $tabs_nav .= '<li><a class="'.$default.'" href="javascript:void(0)" data-content="tab'.$random_id.'">' . wp_kses($icon_content, true) . ''.$tab_attr_array['title'].'</a></li>';
        $tabs_content .= '<div class="section-topline '.$default.'" id="tab' . $random_id . '" ><div class="section-topline-container">'.$tab_attr_array['content'].'</div></div>';

      
    }
    $tabs_nav .= '</ul><!-- .tab-me-tabs -->';
    $tabs_nav .= '</nav><!-- .tab-me-tabs -->';
    $tabs_output = $tabs_nav . '<div class="content-wrapper">' . $tabs_content . '</div>';
    $tabs_output .= '</div><!-- .tabs-wrapper -->';
    return $tabs_output;
}
add_shortcode('tabs', 'tabs_func');

vc_map( array(
    'name' => esc_html__( 'Tabs', 'casaroyal' ),
    'base' => 'tabs',
    'icon' => get_template_directory_uri().'/images/vc-icon.png',
    'description' => esc_html__( 'Custom casaroyal accordion', 'casaroyal' ),
    "as_parent" => array('only' => 'tab'), // Use only|except attributes to limit child shortcodes (separate multiple values with comma)
    "content_element" => true,
    "show_settings_on_create" => false,
    "is_container" => true,
    'params' => array(
        array(
            'type' => 'dropdown',
            'heading' => esc_html__( 'Style', 'casaroyal' ),
            'value' => array(
                esc_html__( 'Horizontal Style 1', 'casaroyal' ) => 'horizontal_1',
                esc_html__( 'Horizontal Style 2', 'casaroyal' ) => 'horizontal_2',
                esc_html__( 'Horizontal Style 3', 'casaroyal' ) => 'horizontal_3',
                esc_html__( 'Vertical Style 1', 'casaroyal' ) => 'vertical_1',
                esc_html__( 'Vertical Style 2', 'casaroyal' ) => 'vertical_2',
                esc_html__( 'Vertical Style 3', 'casaroyal' ) => 'vertical_3',
                esc_html__( 'Vertical Style 4', 'casaroyal' ) => 'vertical_4',
            ),
            'param_name' => 'tabs_style',
            'description' => esc_html__( 'Select tabs style', 'casaroyal' ),
            'std' => 'horizontal_1',
        ),
        array(
            'type' => 'css_editor',
            'heading' => esc_html__( 'CSS box', 'casaroyal' ),
            'param_name' => 'css',
            'group' => esc_html__( 'Design Options', 'casaroyal' ),
        ),
    ),
    "js_view" => 'VcColumnView'
));

//Your "container" content element should extend WPBakeryShortCodesContainer class to inherit all required functionality
if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
    class WPBakeryShortCode_tabs extends WPBakeryShortCodesContainer {
    }
}

