<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_testimonial_func( $atts ) {

	extract( shortcode_atts( array(
		"background" => "light",
    	"css" => "",
   	), $atts ) );

	ob_start();

	$class_to_filter = '';
	$class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	$MODS = get_theme_mods();
    foreach(casaroyal_defaults() as $mod=>$def) {if(!isset($MODS[$mod])){$MODS[$mod]=$def;}}

    // Scroll Animation
    $scroll_animation;
    if(strlen($MODS['scroll_animation'])>0) {
        $scroll_animation = $MODS['scroll_animation'];
    }
    //

	?>

	<div class="testimonials-wrapper <?php echo esc_attr($css_class); ?> <?php if($background == "dark") { echo "dark-bg"; } ?> <?php if($scroll_animation == "on") { ?>aos-init<?php } ?>" <?php if($scroll_animation == "on") { ?>data-aos="fade-right" data-aos-delay="300"<?php } ?>>

		<div class='owl-demo owl-carousel owl-theme owl-testimonials-v3'>

			<?php 

		  		$wp_query_project = null;
				$wp_query_project = new WP_Query();
				$wp_query_project->query('post_type=testimonial&posts_per_page=-1');

			?>
			<?php if ( $wp_query_project->have_posts() ) : ?>
				
				<?php while ($wp_query_project->have_posts()) : $wp_query_project->the_post(); ?>

					<!-- post -->
					<div id="post-<?php the_ID(); ?>" class="item item-testimonials">

						<div class="item-testimonials-container">

							<div class="item-testimonials-body">

								<?php

									$content_text = get_post_field( 'post_content', get_the_ID() );

									if(!empty($content_text)) {

								?>
								<p class="testimonial-quote"><?php echo esc_attr($content_text); ?></p>

								<?php } ?>

								<div class="testimonial-author">

									<?php

										if(has_post_thumbnail()) {

									?>

									<div class="item-testimonials-avatar">

										<?php the_post_thumbnail( 'casaroyal-testimonials' ); ?>

									</div>

									<?php } ?>

									<div class="item-testimonials-author-data">

										<h2><?php the_title(); ?></h2>

										<span class="item-testimonials-meta">
											<?php $position = get_post_meta(get_the_ID(),'ft_testimonial_position',true); echo esc_attr($position); ?>
										</span>

									</div>

								</div>

							</div>

						</div>

					</div>
					<!-- /post -->
		    			        		            
		        <?php endwhile; ?>

			<?php endif; wp_reset_postdata(); ?>

        </div>

	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_testimonial', 'casaroyal_testimonial_func' );

vc_map( array(
  	'name' => esc_html__( 'Testimonials', 'casaroyal' ),
	'base' => 'casaroyal_testimonial',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal testimonials', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Background', 'casaroyal' ),
			'param_name' => 'background',
			'description' => esc_html__( 'Select background style.', 'casaroyal' ),
			'value' => array(
				__( 'Light', 'casaroyal' ) => 'light',
				__( 'Dark', 'casaroyal' ) => 'dark',
			),
			'std' => 'light',
		),
        array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

