<?php

/**
 * The Shortcode
 */
function casaroyal_video_player_func( $atts ) {

	extract( shortcode_atts( array(
    	'link' => 'https://vimeo.com/51589652',
    	'image' => '',
    	'css' => '',
   	), $atts ) );

	ob_start();

	$img_id = preg_replace( '/[^\d]/', '', $image );
	$link_image = wp_get_attachment_image_src( $img_id, 'large' );
	$img_src = $link_image[0];

	$video_w = 500;
	$video_h = $video_w / 1.61; //1.61 golden ratio
	/** @var WP_Embed $wp_embed */
	global $wp_embed;
	$embed = '';
	if ( !empty( $wp_embed ) ) {
		$embed = $wp_embed->run_shortcode( '[embed width="' . $video_w . '"' . $video_h . ']' . $link . '[/embed]' );
	}

	$class_to_filter = 'wpb_video_widget wpb_content_element vc_clearfix';
	$class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	?>

		<div class="video-cover <?php echo esc_attr($css_class); ?>">
			<div class="background-image-holder" style="opacity: 1; background: url(<?php echo esc_url( $img_src ); ?>);"></div>
			<div class="video-play-icon"></div>
			<?php print_r($embed); ?>
		</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_video_player', 'casaroyal_video_player_func' );

vc_map( array(
  	'name' => esc_html__( 'Video Player', 'casaroyal' ),
	'base' => 'casaroyal_video_player',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Embed YouTube/Vimeo player', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'textfield',
			'heading' => esc_html__( 'Video link', 'casaroyal' ),
			'param_name' => 'link',
			'value' => 'https://vimeo.com/51589652',
			'admin_label' => true,
			'description' => sprintf( esc_html__( 'Enter link to video (Note: read more about available formats at WordPress <a href="%s" target="_blank">codex page</a>).', 'casaroyal' ), 'http://codex.wordpress.org/Embeds#Okay.2C_So_What_Sites_Can_I_Embed_From.3F' ),
		),
		array(
			'type' => 'attach_image',
			'heading' => esc_html__( 'Image', 'casaroyal' ),
			'param_name' => 'image',
			'value' => '',
			'description' => esc_html__( 'Select image from media library.', 'casaroyal' ),
		),
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

