<?php

/**
 * The Shortcode
 */

/**
 * Shortcode attributes
 * @var $atts
 * @var $title
 * @var $images
 * @var $css
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_gallery
 */

function casaroyal_woocommerce_categories_func( $atts, $content ) {

	extract( shortcode_atts( array(
    	'css' => '',
   	), $atts ) );

	ob_start();

	$class_to_filter = vc_shortcode_custom_css_class( $css, ' ' );
	$css_class = $class_to_filter;

	?>

	<div class="casaroyal-woocommerce-categories-vertical <?php echo esc_attr($css_class); ?>">

		<ul class="casaroyal-woocommerce-categories-vertical-list">

			<li class="casaroyal-woocommerce-categories-vertical-header"><?php esc_html_e( 'Browse Categories', 'casaroyal' ); ?></li>

			<?php if (class_exists('casaroyal')) { ?>

            <?php

    			$args = array(
				    'hide_empty' => false,
				    'orderby' => 'term_id',
				);

				$current = 0;

    			$terms = get_terms( 'product_cat', $args );

				if ( $terms ) {

					foreach ( $terms as $term ) {

						$product_cat_icon = get_woocommerce_term_meta( $term->term_id, 'product_cat_icon', true );
						$category_icon = stripslashes($product_cat_icon); 

						echo '<li><a class="casaroyal-woocommerce-categories-vertical-links" href="' .  esc_url( get_term_link( $term ) ) . '" class="' . $term->slug . '">';
							echo wp_kses($category_icon, true);
	                        echo $term->name;
	                    echo '</a></li>';

					}

				}

    		?>

    		<?php } else { ?>

				<li><p><?php esc_html_e( 'WooCommerce not installed!', 'casaroyal' ); ?><p></li>

			<?php } ?>

		</ul>
			
	</div>

	<?php

	return ob_get_clean();

}
add_shortcode( 'casaroyal_woocommerce_categories', 'casaroyal_woocommerce_categories_func' );

vc_map( array(
  	'name' => esc_html__( 'WooCommerce Categories', 'casaroyal' ),
	'base' => 'casaroyal_woocommerce_categories',
	'icon' => get_template_directory_uri().'/images/vc-icon.png',
	'category' => esc_html__( 'casaroyal', 'casaroyal' ),
	'description' => esc_html__( 'Custom casaroyal woocommerce categories vertical block', 'casaroyal' ),
	'params' => array(
		array(
			'type' => 'css_editor',
			'heading' => esc_html__( 'CSS box', 'casaroyal' ),
			'param_name' => 'css',
			'group' => esc_html__( 'Design Options', 'casaroyal' ),
		),
	),
));

